(function($) {
    'use strict';

    jQuery(document).ready(function() {

        var ElementCheck = document.getElementById("qcld-express-toggler");

        if(ElementCheck){

            // Added to cart JS
            $(document.body).on('added_to_cart', function() {            
                
                $('#qcld-express-toggler').addClass( 'hascart');

                var targetClass = $('#qcld-express-toggler');

                if (targetClass.hasClass('hascart')) {

                    if(cart_mode == 'wooinstants'){
                        if ( wiCartTotal > 0 ) {
                            $('#qcld-express-toggler').addClass( 'hascart' );
                        } else {
                            $('#qcld-express-toggler').removeClass( 'hascart' );
                        }
                    }

                    // Update Cart on added to card
                    jQuery('[name="update_cart"]').trigger( 'click' );
                    

                    setTimeout(function(){ 

                        if(qcld_express_plus_minus_icon_qty == 'on'){
                        triggerForPlusMiusquickViewCartUpdate();
                            
                        }


                    }, 3000);

                }
            });


        function triggerForPlusMiusquickViewCartUpdate(){

            $('input.qcld_express_quick_plus').remove();
            $('input.qcld_express_quick_minus').remove();

            var CurrentDom = $('input.input-text.qty');
            var CheckDomPlus = $('input.input-text.qty').closest('.product-quantity').find('.qcld_express_quick_plus').length;
            var CheckDomMinus = $('input.input-text.qty').closest('.product-quantity').find('.qcld_express_quick_minus').length;


            if( CheckDomPlus > 0 || CheckDomMinus > 0 ){
                return;
            }

            $(CurrentDom).before('<input class="qcld_express_quick_minus" type="button" value="-">');
            $(CurrentDom).after('<input class="qcld_express_quick_plus" type="button" value="+">');


        }



        // Update cart total JS
        $(document.body).on('updated_cart_totals', function() {
            jQuery('.woocommerce-cart-form:not(:last)').remove();
            jQuery('.cart_totals:not(:last)').remove();
        });

        // Applied Coupon JS
        $(document.body).on('applied_coupon', function() {
            setTimeout(
                function() {
                    jQuery('.woocommerce-cart-form:not(:last)').remove();
                }, 1000);
        });

        // Remove Coupon JS
        $(document.body).on('removed_coupon', function() {
            jQuery('.woocommerce-cart-form:not(:last)').remove();
        });

        // Update shipping method JS
        $(document.body).on('updated_shipping_method', function() {
            jQuery('.woocommerce-cart-form:not(:last)').remove();
        });

        // Checkout area toggle JS
        $(document).on('click', '#qcld-express-cart-area .checkout-button', function(e) {
            e.preventDefault();

            jQuery('#qcld-express-cart-area').fadeOut();
            jQuery('#qcld-express-checkout-area').fadeIn();


            // Update checkout on country changing JS
            $('#billing_country, #shipping_country, .country_to_state, .state_select').select2({
                width: '100%'               
            });
        });

        // Back to cart from checkout JS
        $(document).on('click', '#back_to_cart', function() {
            jQuery('#qcld-express-cart-area').fadeIn();
            jQuery('#qcld-express-checkout-area').fadeOut();
        });

        // Update checkout on country changing JS
        $(document).on('change', '#billing_country, #shipping_country, .country_to_state', function() {
            jQuery(document.body).trigger('update_checkout');
        });

        // Payment method clicking JS
        $(document).on('click', '.payment_methods input.input-radio', function() {

            if ($('.payment_methods input.input-radio').length > 1) {
                var target_payment_box = $('div.payment_box.' + $(this).attr('ID')),
                    is_checked = $(this).is(':checked');

                if (is_checked && !target_payment_box.is(':visible')) {
                    $('div.payment_box').filter(':visible').slideUp(230);

                    if (is_checked) {
                        target_payment_box.slideDown(230);
                    }
                }

            } else {
                $('div.payment_box').show();
            }

            if ($(this).data('order_button_text')) {
                $('#place_order').text($(this).data('order_button_text'));
            } else {
                $('#place_order').text($('#place_order').data('value'));
            }

        });

        $(document).on('change', '#ship-to-different-address input', function() {
            jQuery(document.body).trigger('update_checkout');

            $('.shipping_address').hide();
            if ($(this).is(':checked')) {
                $('.shipping_address').slideDown();
            }
        });

      
            //Show cart function
            function showCarts(){
                var data = {
                    'action': 'show_cart',
                    'security': qcld_express_security_nonce
                };

                jQuery.post(ajaxurl, data, function (response) {

                    if(qcld_quick_cart_stop_expand == 'off'){
                        //showing cart first
                        $('.qcld-express-shop-float-cart').addClass('active-float-cart');
                        $('.qcld-express-shop-right-float-cart').addClass('active-float-cart');
                    }
                    //Then appending datta.
                    $(".qcld-express-show-cart-data").html(response.html);
                    $(".qcld-express-cart-item-num").html(response.items);
                    //display the top cart as block
                    $('#qcld-express-cart-container').css({'display':'block'});
                    //push the body to right
                    if(cart_mode=='float') {
                        $('body').css({'margin-left': '350px', 'background': 'rgba(0,0,0,0.4)', 'transition': '0.8s'});
                        qclad_express_preloader.off();
                    } else if(cart_mode=='top'){
                        $("html, body").animate({ scrollTop:100 }, 1000);
                        return false;
                    }
                     //if on the product details fancy box display none.
                    $.magnificPopup.close();
                });

            }


        }


    });
    
})(jQuery);

