
jQuery(document).ready(function($)
{

    //Initialize the metarial preloader

    $('body').on('click', function(event) {
        if (!$(event.target).is('.qcld-express-popup-tooltip') && $(event.target).closest('.qcld-express-popup-tooltip').length) return;
        $('.qcld-express-popup-tooltip').hide();
    });
    

    //Show cart function
    function showCart(){
            var data = {
                'action': 'show_cart',
                'security': qcld_express_security_nonce
            };

            jQuery.post(ajaxurl, data, function (response) {
                if(qcld_quick_cart_stop_expand == 'off'){
                    //showing cart first
                    $('.qcld-express-shop-float-cart').addClass('active-float-cart');
                    $('.qcld-express-shop-right-float-cart').addClass('active-float-cart');
                }
                //Then appending datta.
                $(".qcld-express-show-cart-data").html(response.html);
                $(".qcld-express-cart-item-num").html(response.items);
                //display the top cart as block
                $('#qcld-express-cart-container').css({'display':'block'});
                //push the body to right
                if(cart_mode=='float') {
                    $('body').css({'margin-left': '350px', 'background': qcld_express_active_body_bg, 'transition': '0.8s'});
                    qclad_express_preloader.off();
                } else if(cart_mode=='top'){
                    $("html, body").animate({ scrollTop:100 }, 1000);
                    return false;
                }
                 //if on the product details fancy box display none.
                $.magnificPopup.close();
            });

        
    }
	//Close the top cart summary
    $(document).on('click','#show-top-cart-close',function () {
        $('#qcld-express-cart-container').css({'display':'none'});
    })
	//Close the float cart summary
    $(document).on('click','#show-float-cart-close',function () {
        //$('#qcld-express-cart-container').html("");
        $('.qcld-express-shop-float-cart').removeClass('active-float-cart');
        $('body').css({'margin-left':'0px','transition': '0.8s', 'background': 'transparent'});
    });
	//To show Left floating cart
    $(document).on('click','#float-cart-btn',function () {
        showCart();

        $('.qcld-express-shop-float-cart').addClass('active-float-cart');
        $('body').css({'margin-left':'350px','background':qcld_express_active_body_bg,'transition': '0.8s'});
    });

    //Close the right float cart summary
    $(document).on('click','#right-show-float-cart-close',function () {
        //$('#qcld-express-cart-container').html("");
        $('.qcld-express-shop-right-float-cart').removeClass('active-float-cart');
        $('body').css({'margin-right':'0px','transition': '0.8s', 'background': 'transparent'});
    });

    //To show right floating cart
    $(document).on('click','#right-float-cart-btn',function () {
        showCart();
        $('.qcld-express-shop-right-float-cart').addClass('active-float-cart');
        $('body').css({'margin-right':'350px','background':qcld_express_active_body_bg,'transition': '0.8s'});
    });
    //Global cart showing from shop page
    $(document).on('click', '.add_to_cart_button', function () {
        if (!$(this).hasClass('product_type_variable')) {
            var data = {
                   'action': 'show_cart',
                   'security': qcld_express_security_nonce
               };
            setTimeout(function () {
                jQuery.post(ajaxurl, data, function (response) {
                    
                    showCart();

                });
            }, 500);
        }
    });
    //Global cart showing from related product
    $(document).on('click', '.product_type_simple', function () {
        if (!$(this).hasClass('product_type_variable')) {
             var data = {
                   'action': 'show_cart',
                   'security': qcld_express_security_nonce
               };
            setTimeout(function () {
                jQuery.post(ajaxurl, data, function (response) {
                    
                    showCart();

                });
            }, 500);
       }
    });
    //Global add to cart and showing cart from product page for simple product.

    //Update floating cart items by removing from theme cart page.
    $(document).on("click", ".product-remove a, input[name=update_cart]", function () {
        setTimeout(function () {
            var data = {
                'action': 'remove_item_numbers_from_cart',
                'security': qcld_express_security_nonce
            };

            jQuery.post(ajaxurl, data, function (response) {
                //update the cart item and number.
                $('.qcld-express-cart-item-num').html(response);
                showCart();
            });
        }, 1000);
    });
    //remove the cart item from global cart.
    $(document).on("click", ".qcld-remove-cart-item", function (e) {
         e.preventDefault();

         qclad_express_preloader.on();
         var cart_item=$(this).attr('data-cart-item');
            var data = {
                'action': 'global_cart_item_remove',
                'cart_item': cart_item,
                'security': qcld_express_security_nonce
            };
            
            jQuery.post(ajaxurl, data, function (response) {
                showCart();
            });

            qclad_express_preloader.off();

    });

    //Cart item number update from global cart.
    $(document).on("change", ".qcld-cart-item-qnty", function () {
        var currentItem=$(this);
        setTimeout(function () {
            qclad_express_preloader.on();
            var item_key=currentItem.attr('data-cart-item');
            var qnty=currentItem.val();
            update_cart_item_number(item_key,qnty)
        }, 300);

        qclad_express_preloader.off();

        jQuery('[name="update_cart"]').trigger( 'click' );
    });

    function update_cart_item_number(item_key,qnty){
        var data = {
            'action': 'update_cart_item_number',
            'cart_item_key':item_key,
            'qnty':qnty,
            'security': qcld_express_security_nonce
        };

        jQuery.post(ajaxurl, data, function (response) {
            //console.log(JSON.stringify(response));
            //Now hide the tooltip
            showCart();
        });
    }

    $(document).ready(function() {
        showCart();
    });

    

    $(document).on('keypress','#qcld_sku,#qcld_title,#qcld_price_min,#qcld_price_max',function(event) {
        if(event.which === 13){
            $('#submit_search').trigger('click');
        }
    });

    // Preloader function here..
    function searchPreloaders() {

        show = function(){
            
            $('body').prepend('<div class="before-loading"><div class="spin" id="spin3"></div></div>');
            setTimeout(hide, 3000); 
        },

        hide = function(){
            $('.before-loading').hide();
        };
               
        show();

    };

    // category active class add and remove..
    $(document).ready(function(){
        $('.slick-slide a.qcld-express-active-category').click(function(){
            $('.slick-slide a.qcld-express-active-category').removeClass("active");
            $(this).addClass("active");
        });
    });



    //attach event handler to close button

    $(".mfp-close").on('click', function(){
        qcld_stopVid();
    });




});