/******************************
 Metarial preloader plugin start
 ******************************/
(function(e) {
    var t = {
        position: "bottom",
        height: "5px",
        col_1: "#159756",
        col_2: "#da4733",
        col_3: "#3b78e7",
        col_4: "#fdba2c",
        fadeIn: 200,
        fadeOut: 200
    };
    e.materialPreloader = function(n) {
        var r = e.extend({}, t, n);
        $template = "<div id='materialPreloader' class='load-bar' style='height:" + r.height + ";display:none;" + r.position + ":0px'><div class='load-bar-container'><div class='load-bar-base base1' style='background:" + r.col_1 + "'><div class='color red' style='background:" + r.col_2 + "'></div><div class='color blue' style='background:" + r.col_3 + "'></div><div class='color yellow' style='background:" + r.col_4 + "'></div><div class='color green' style='background:" + r.col_1 + "'></div></div></div> <div class='load-bar-container'><div class='load-bar-base base2' style='background:" + r.col_1 + "'><div class='color red' style='background:" + r.col_2 + "'></div><div class='color blue' style='background:" + r.col_3 + "'></div><div class='color yellow' style='background:" + r.col_4 + "'></div> <div class='color green' style='background:" + r.col_1 + "'></div> </div> </div> </div>";
        e(".qcld-express-shop-float-cart").prepend($template);
        this.on = function() {
            e("#materialPreloader").fadeIn(r.fadeIn)
        };
        this.off = function() {
            e("#materialPreloader").fadeOut(r.fadeOut)
        }
    }
})(jQuery)
/******************************
 Metarial preloader plugin end
 ******************************/

jQuery(document).ready(function($)
{



    //Initialize the metarial preloader
    qclad_express_preloader = new $.materialPreloader({
        position: 'top',
        height: '8px',
        col_1: '#159756',
        col_2: '#da4733',
        col_3: '#3b78e7',
        col_4: '#fdba2c',
        fadeIn: 200,
        fadeOut: 200
    });

    //woo instant redirect checkout page
    $('.qcld-express-inner .wc-proceed-to-checkout a').removeClass('checkout-button');
    $('.qcld-express-container .wc-proceed-to-checkout a').attr('href', qcld_get_checkout_url);

    /***************************************
     *  Add to cart & Cart showing start   *
     ***************************************/
    //Bring variable products to configure layout.
    $(document).on("click",".qcld_express_v_p",function(e) {
        e.preventDefault();

        var currentDom=$(this);

        $.magnificPopup.open({items: {src: '#qcld-express-modal-fancy'},type: 'inline'}, 0);
        //Change button text
        currentDom.html('<i class="fa fa-spinner" aria-hidden="true"></i>');
        var pId=$(this).attr('p-id');
        //Ajax Start for get product attributes.
        var data = {
            'action': 'get_vp_attributes',
            'p_id': pId,
            'security': qcld_express_security_nonce
        };

        jQuery.post(ajaxurl, data, function (response) {
            //Change button text
            currentDom.html('<i class="fa fa-shopping-cart" aria-hidden="true"></i>');
            $("#qcld-express-modal").html(response);
        });

    });
    //Bring variable products to configure layout.
    $(document).on("click",".qcld_express_v_p_tooltip",function(e) {
        e.preventDefault();

        $('.qcld-express-action-cell .qcld-express-popup-tooltip').remove();
    	var currentDom=$(this);
        var tooltip_warp = currentDom.parent().parent().parent();
        console.log(tooltip_warp.html());
        //Change button text
        currentDom.html('<i class="fa fa-spinner" aria-hidden="true"></i>');
        var pId=$(this).attr('p-id');
        //Ajax Start for get product attributes.
        var data = {
            'action': 'qcld_express_pro_get_vp_attributes_tooltip',
            'p_id': pId,
            'security': qcld_express_security_nonce
        };

        jQuery.post(ajaxurl, data, function (response) {
        	//Change button text
            currentDom.html('<i class="fa fa-shopping-cart" aria-hidden="true"></i>');
            
            tooltip_warp.append(response).slideDown("fast");
        });

	});



    $('body').on('click', function(event) {
        if (!$(event.target).is('.qcld-express-popup-tooltip') && $(event.target).closest('.qcld-express-popup-tooltip').length) return;
        $('.qcld-express-popup-tooltip').hide();
    });
    



    //Variable product add to cart
    $(document).on('click','#v_p_add_to_cart',function(event) {
        event.preventDefault();

        var pId=$(this).attr('p-id');
        var quanity=$('#vPQuantity').val();
        // alert(quanity);
        var variations_id=$(this).attr('variation_id');
        var attributes=new Array();
        $.each($("#qcld-express-modal select"), function(){
            var attribute = $(this).attr('name')+'#'+ $(this).find('option:selected').text();
            attributes.push(attribute);
        });
        //alert(attributes);
        var data = {
            'action': 'vp_add_to_cart',
            'p_id': pId,
            'quantity': quanity,
            'variations_id': variations_id,
            'attributes': attributes
        };

        jQuery.post(ajaxurl, data, function (response) {
        // Hide the variable product modal.
       // console.log(response);
            $.magnificPopup.close();
            //load the newly added product to the cart
            showCart();

            if(qcld_quick_cart_stop_expand == 'off'){

                $('.qcld-express-shop-right-float-cart').addClass('active-float-cart');
                if($('.qcld-express-shop-right-float-cart').hasClass('active-float-cart')){
                    $('body').css({'margin-right':'350px','background':'rgba(0,0,0,0.4)','transition': '0.8s'});
                }

                $('.qcld-express-shop-float-cart').addClass('active-float-cart');
                if($('.qcld-express-shop-float-cart').hasClass('active-float-cart')){
                    $('body').css({'margin-left':'350px','background':'rgba(0,0,0,0.4)','transition': '0.8s'});
                }

            }

        });
    });



    //Handling attributes  for variable product by changing each attribute. popup modal
   /* $(document).on('change',".qcld-express-product-details select",function () {
        var variations= JSON.parse($("#qcld_epress_product_title").attr('data-product-variation'));
        
        var item_conditions = [];
                
        var totalAttr = $(".qcld-express-product-details select").length;
        var i=1;
        $(".qcld-express-product-details select").each(function(index, element) {
            var myVal = $(this).find('option:selected').val();

            if(myVal!=""){

                item_conditions.push({'left':'item["variation_data"]["'+$(this).attr('name')+'"][0]','right':myVal });

            }

        });


        var newVariation=[];
        for(var a=0; variations.length>a ;a++){
           var item=variations[a];
           var item_condition="";
           for(var i=0;item_conditions.length>i;i++){
            //console.log(eval(item_conditions[i].left).toLowerCase());
               if(i>0){
                   item_condition+=  ' && '+'"'+ eval(item_conditions[i].left).toLowerCase()+'"'+'=='+'"'+item_conditions[i].right.toLowerCase()+'"';
               }else{
                   item_condition+= '"'+ eval(item_conditions[i].left).toLowerCase()+'"'+'=='+'"'+item_conditions[i].right.toLowerCase()+'"';

               }
           }
           if(eval(item_condition)){
               newVariation[0]=item;
           }
        }

        //console.log(JSON.stringify(newVariation));
        if(newVariation.length>0) {
            $('.qcld_express_v_p_pop_up').attr('variation_id',newVariation[0]['variation_id']);

            if(newVariation[0]['variation_data']['_sale_price'][0] == ""){

               $('#qcld_express_vp_price').html('<strong>'+currency_symbol+newVariation[0]['variation_data']['_regular_price'][0]+'</strong>');
                
            }else{
                
                $('#qcld_express_vp_price').html('<strike>'+currency_symbol+newVariation[0]['variation_data']['_regular_price'][0]+'</strike>  <strong>'+currency_symbol+ newVariation[0]['variation_data']['_sale_price'][0]+'</strong>');
            }

        }


    });*/


    //Variable product add to cart by popup modal
    $(document).on('click','.qcld_express_v_p_pop_up',function(event) {
        event.preventDefault();


        var currentDom=$(this);
        currentDom.html('<i class="fa fa-spinner" aria-hidden="true"></i> ADD TO CART');

        var pId=$(this).attr('p-id');
        var quanity=$('#qcld_quantity_value').val();
        // alert(quanity);
        var variations_id=$(this).attr('variation_id');
        var attributes=new Array();
        $.each($(".qcld-express-product-details select"), function(){
            var attribute = $(this).attr('name')+'#'+ $(this).find('option:selected').text();
            attributes.push(attribute);
        });
        //alert(attributes);
        var data = {
            'action': 'vp_add_to_cart',
            'p_id': pId,
            'quantity': quanity,
            'variations_id':variations_id,
            'attributes':attributes
        };

        jQuery.post(ajaxurl, data, function (response) {
            //load the newly added product to the cart
            currentDom.html('ADD TO CART');
            $.magnificPopup.close();
            showCart();

            if(qcld_quick_cart_stop_expand == 'off'){
            
                $('.qcld-express-shop-right-float-cart').addClass('active-float-cart');
                if($('.qcld-express-shop-right-float-cart').hasClass('active-float-cart')){
                    $('body').css({'margin-right':'350px','background':'rgba(0,0,0,0.4)','transition': '0.8s'});
                }

                $('.qcld-express-shop-float-cart').addClass('active-float-cart');
                if($('.qcld-express-shop-float-cart').hasClass('active-float-cart')){
                    $('body').css({'margin-left':'350px','background':'rgba(0,0,0,0.4)','transition': '0.8s'});
                }

            }

        });
    });



    //Handling item number should be greater than zero.
    $(document).on('change','.qcld-express-simple-p-qnty, .quantity input',function (event) {
        if($(this).val()<1){
            //alert('Item number can not be less than one.')
            $(this).val(1);
        }
    });
    //Add to cart for simple product.
    $(document).on("click",".qcld_express_s_p",function(event) {
        event.preventDefault();
        //Change button text
        var currentDom=$(this);
        currentDom.html('<i class="fa fa-spinner" aria-hidden="true"></i>');
    	var pId=$(this).attr('p-id');
    	var qnty=$(this).closest(".qcld-express-action").find("input[name='qcld_quantity']").val();
    	var pPrice=$(this).attr('p-price');
        var data = {
            'action': 'sp_add_to_cart',
            'p_id': pId,
            'quantity': qnty,
            'p_price': pPrice,
        };
         //Fly image to cart  start
			if(cart_mode=='float'){
			var itemImg = currentDom.parent().parent().parent().children('.qcld-express-thumb-cell').find('img');
			//flyToElement($(itemImg), $('.qcld-express-cart-item-num'));
			} 
        //Fly image to cart  end
        jQuery.post(ajaxurl, data, function (response) {
            //Change button text
            currentDom.html('<i class="fa fa-shopping-cart"></i>');
             if(response=="simple"){
                 showCart();

                if(qcld_quick_cart_stop_expand == 'off'){

                    $('.qcld-express-shop-right-float-cart').addClass('active-float-cart');
                    if($('.qcld-express-shop-right-float-cart').hasClass('active-float-cart')){
                        $('body').css({'margin-right':'350px','background':'rgba(0,0,0,0.4)','transition': '0.8s'});
                    }

                    $('.qcld-express-shop-float-cart').addClass('active-float-cart');
                    if($('.qcld-express-shop-float-cart').hasClass('active-float-cart')){
                        $('body').css({'margin-left':'350px','background':'rgba(0,0,0,0.4)','transition': '0.8s'});
                    }

                }
                
			 } else{
             	alert('Try again!');
			 }
		});

       // setTimeout(function(){ showCart(); }, 2000);
    });


    //Show cart function
    function showCart(){
        var data = {
            'action': 'show_cart',
            'security': qcld_express_security_nonce
        };

        jQuery.post(ajaxurl, data, function (response) {
            if(qcld_quick_cart_stop_expand == 'off'){
                //showing cart first
                $('.qcld-express-shop-float-cart').addClass('active-float-cart');
                $('.qcld-express-shop-right-float-cart').addClass('active-float-cart');
            }
            //Then appending datta.
            $(".qcld-express-show-cart-data").html(response.html);
            $(".qcld-express-cart-item-num").html(response.items);
            //display the top cart as block
            $('#qcld-express-cart-container').css({'display':'block'});
            //push the body to right
            if(cart_mode=='float') {
                $('body').css({'margin-left': '350px', 'background': qcld_express_active_body_bg, 'transition': '0.8s'});
                qclad_express_preloader.off();
            } else if(cart_mode=='top'){
                $("html, body").animate({ scrollTop:100 }, 1000);
                return false;
            }
             //if on the product details fancy box display none.
            $.magnificPopup.close();
        });

        
    }
	//Close the top cart summary
    $(document).on('click','#show-top-cart-close',function () {
        $('#qcld-express-cart-container').css({'display':'none'});
    })
	//Close the float cart summary
    $(document).on('click','#show-float-cart-close',function () {
        //$('#qcld-express-cart-container').html("");
        $('.qcld-express-shop-float-cart').removeClass('active-float-cart');
        $('body').css({'margin-left':'0px','transition': '0.8s', 'background': 'transparent'});
    });
	//To show Left floating cart
    $(document).on('click','#float-cart-btn',function () {
        showCart();

        $('.qcld-express-shop-float-cart').addClass('active-float-cart');
        $('body').css({'margin-left':'350px','background':qcld_express_active_body_bg,'transition': '0.8s'});
    });

    //Close the right float cart summary
    $(document).on('click','#right-show-float-cart-close',function () {
        //$('#qcld-express-cart-container').html("");
        $('.qcld-express-shop-right-float-cart').removeClass('active-float-cart');
        $('body').css({'margin-right':'0px','transition': '0.8s', 'background': 'transparent'});
    });

    //To show right floating cart
    $(document).on('click','#right-float-cart-btn',function () {
        showCart();
        $('.qcld-express-shop-right-float-cart').addClass('active-float-cart');
        $('body').css({'margin-right':'350px','background':qcld_express_active_body_bg,'transition': '0.8s'});
    });
    //Global cart showing from shop page
    $(document).on('click', '.add_to_cart_button', function () {
        if (!$(this).hasClass('product_type_variable')) {
            var data = {
                   'action': 'show_cart',
                   'security': qcld_express_security_nonce
               };
            setTimeout(function () {
                jQuery.post(ajaxurl, data, function (response) {
                    
                    showCart();

                });
            }, 500);
        }
    });
    //Global cart showing from related product
    $(document).on('click', '.product_type_simple', function () {
        if (!$(this).hasClass('product_type_variable')) {
             var data = {
                   'action': 'show_cart',
                   'security': qcld_express_security_nonce
               };
            setTimeout(function () {
                jQuery.post(ajaxurl, data, function (response) {
                    
                    showCart();

                });
            }, 500);
       }
    });
    //Global add to cart and showing cart from product page for simple product.

    //Update floating cart items by removing from theme cart page.
    $(document).on("click", ".product-remove a, input[name=update_cart]", function () {
        setTimeout(function () {
            var data = {
                'action': 'remove_item_numbers_from_cart',
                'security': qcld_express_security_nonce
            };

            jQuery.post(ajaxurl, data, function (response) {
                //update the cart item and number.
                $('.qcld-express-cart-item-num').html(response);
                showCart();
            });
        }, 1000);
    });
    //remove the cart item from global cart.
    $(document).on("click", ".qcld-remove-cart-item", function (e) {
         e.preventDefault();

         qclad_express_preloader.on();
         var cart_item=$(this).attr('data-cart-item');
            var data = {
                'action': 'global_cart_item_remove',
                'cart_item': cart_item,
                'security': qcld_express_security_nonce
            };
            
            jQuery.post(ajaxurl, data, function (response) {
                showCart();
            });

            qclad_express_preloader.off();

    });

    //Cart item number update from global cart.
    $(document).on("change", ".qcld-cart-item-qnty", function () {
        var currentItem=$(this);
        setTimeout(function () {
            qclad_express_preloader.on();
            var item_key=currentItem.attr('data-cart-item');
            var qnty=currentItem.val();
            update_cart_item_number(item_key,qnty)
        }, 300);

        qclad_express_preloader.off();

        jQuery('[name="update_cart"]').trigger( 'click' );
    });

    function update_cart_item_number(item_key,qnty){
        var data = {
            'action': 'update_cart_item_number',
            'cart_item_key':item_key,
            'qnty':qnty,
            'security': qcld_express_security_nonce
        };

        jQuery.post(ajaxurl, data, function (response) {
            //console.log(JSON.stringify(response));
            //Now hide the tooltip
            showCart();
        });
    }

    $(document).ready(function() {
        showCart();
    });

    /***************************************
     *  Add to cart & Cart showing End   *
     ***************************************/

    /***************************************
     *  Sorting sku,title and price start   *
     ***************************************/
    //Sku sorting.
    if(localStorage.getItem('sku-sort')){
        if(localStorage.getItem('sku-sort')=='sku_DESC'){
           // $('#sku-sort .fa').addClass('fa-arrow-up').removeClass('fa-arrow-down');
        } else{
           // $('#sku-sort .fa').addClass('fa-arrow-down').removeClass('fa-arrow-up');
        }
    }
   $("#sku-sort").on('click',function (e) {
       e.preventDefault();
      var url=$(this).attr('href');
      var paramName="product_list_order";
      if(localStorage.getItem('sku-sort')){
          if(localStorage.getItem('sku-sort')=='sku_DESC'){
              var paramSku='sku_DESC';
              localStorage.removeItem('sku-sort');
              localStorage.setItem('sku-sort','sku_ASC');
          } else{
              var paramSku= 'sku_ASC';
              localStorage.removeItem('sku-sort');
              localStorage.setItem('sku-sort','sku_DESC');
          }
      } else{
          var paramSku= 'sku_ASC';
          localStorage.setItem('sku-sort','sku_DESC');
      }
       //var newUrl=replaceUrlParam(url, paramName, paramSku);
      // window.location.href = newUrl;
    });
    //Title sort
    if(localStorage.getItem('title-sort')){
        if(localStorage.getItem('title-sort')=='title_DESC'){
            //$('#title-sort .fa').addClass('fa-arrow-up').removeClass('fa-arrow-down');
        } else{
           // $('#title-sort .fa').addClass('fa-arrow-down').removeClass('fa-arrow-up');
        }
    }
    $("#title-sort").on('click',function (e) {
        e.preventDefault();
        var url=$(this).attr('href');
        var paramName="product_list_order";
        if(localStorage.getItem('title-sort')){
            if(localStorage.getItem('title-sort')=='title_DESC'){
                var paramSku='title_DESC';
                localStorage.removeItem('title-sort');
                localStorage.setItem('title-sort','title_ASC');
            } else{
                var paramSku= 'title_ASC';
                localStorage.removeItem('title-sort');
                localStorage.setItem('title-sort','title_DESC');
            }
        } else{
            var paramSku= 'title_ASC';
            localStorage.setItem('title-sort','sku_DESC');
        }
        //var newUrl=replaceUrlParam(url, paramName, paramSku);
        //window.location.href = newUrl;
    });
    //Price sorting
    if(localStorage.getItem('price-sort')){
        if(localStorage.getItem('price-sort')=='price_DESC'){
           // $('#price-sort .fa').addClass('fa-arrow-up').removeClass('fa-arrow-down');
        } else{
           // $('#price-sort .fa').addClass('fa-arrow-down').removeClass('fa-arrow-up');
        }
    }
    $("#price-sort").on('click',function (e) {
        e.preventDefault();
        var url=$(this).attr('href');
        var paramName="product_list_order";
        if(localStorage.getItem('price-sort')){
            if(localStorage.getItem('price-sort')=='price_DESC'){
                var paramSku='price_DESC';
                localStorage.removeItem('price-sort');
                localStorage.setItem('price-sort','price_ASC');
            } else{
                var paramSku= 'price_ASC';
                localStorage.removeItem('price-sort');
                localStorage.setItem('price-sort','price_DESC');
            }
        } else{
            var paramSku= 'price_ASC';
            localStorage.setItem('price-sort','price_DESC');
        }
        // var newUrl=replaceUrlParam(url, paramName, paramSku);
        // window.location.href = newUrl;
    });

    function replaceUrlParam(url, paramName, paramValue){
        if(paramValue == null)
            paramValue = '';
        var pattern = new RegExp('\\b('+paramName+'=).*?(&|$)')
        if(url.search(pattern)>=0){
            return url.replace(pattern,'$1' + paramValue + '$2');
        }
        return url + (url.indexOf('?')>0 ? '&' : '?') + paramName + '=' + paramValue
    }
    /***************************************
     *  Sorting sku,title and price End   *
     ***************************************/

    /*************************************************
     * Ajax load more & infinite scroll products start *
     ************************************************/
   //Load More
    $(document).on("click","#qcld-express-more",function() {
        //alert('hello');
        var currentDom=$(this);
        var actionType="more";
        qcld_express_pro_load_more(currentDom,actionType);

        $('.qcld-express-popup-img').magnificPopup({
          type: 'image',
          closeOnContentClick: true,
          closeBtnInside: false,
          fixedContentPos: true,
          mainClass: 'mfp-no-margins mfp-with-zoom',
          image: {
            verticalFit: true
          },
          zoom: {
            enabled: true,
            duration: 300 
          }
        });
    });
    //Infinite Scrolling
    $(window).on("scroll", function() {

        if($("#qcld-express-scroll").length > 0){
            var scrollHeight = $(document).height();

            var scrollPosition = $(window).height() + $(window).scrollTop();
            var scrollVal=(scrollHeight - scrollPosition) / scrollHeight;
            if (scrollVal.toFixed(2)<= 0.02) {
                var currentDom=$("#qcld-express-scroll");
                currentDom.css({'display':'inline-block'});
                var actionType="scroll";
                qcld_express_pro_load_more(currentDom,actionType);
                //alert('working');

                 $('.qcld-express-popup-img').magnificPopup({
                  type: 'image',
                  closeOnContentClick: true,
                  closeBtnInside: false,
                  fixedContentPos: true,
                  mainClass: 'mfp-no-margins mfp-with-zoom',
                  image: {
                    verticalFit: true
                  },
                  zoom: {
                    enabled: true,
                    duration: 300 
                  }
                });
            }
        }
    });

    function qcld_express_pro_load_more(currentDom,actionType){
        //currentDom.html('<h3>Loading..</h3>');
        $('#load-more-pre-loader').html('<img src="'+qcld_express_image_loader+'"/>');
        currentDom.css({'display':'inline-block'});
        var offset=currentDom.attr('data-offset');
        var category_name = currentDom.attr('data-cat');
        var link_title_to_modal = currentDom.attr('title-modal');
        var sorting_val= currentDom.attr('qcld-hot-deal');
        var audio_feature= currentDom.attr('audio_feature');
        var video_feature= currentDom.attr('video_feature');
        var category_ids= currentDom.attr('category_ids');
        var author= currentDom.attr('author');

        var data = {
            'action' : 'load_more',
            'offset' : offset,
            'link_title_to_modal' : link_title_to_modal,
            'c_id'   : category_name,
            'sorting_val' : sorting_val,
            'audio_feature' : audio_feature,
            'video_feature' : video_feature,
            'category_ids' : category_ids,
            'author' : author,
            'security': qcld_express_security_nonce
        };


        jQuery.post(ajaxurl, data, function (response) {
            $('#load-more-pre-loader').html('');
            //Showing more product by appending to the list.
            $('.qcld-express-product-container').append(response.html);
            $(".qcld-express-categorie a").attr("href", "#");
           //console.log(response);
            addCssWhenResize();
            if(response.offset==-1){
                if(actionType=='more'){
                    currentDom.css({'display':'none'});
                }else if(actionType=='scroll'){
                    currentDom.css({'display':'none'});
                    // $(window).unbind('scroll');
                }else{
                    currentDom.css({'display':'none'});
                    $(window).unbind('scroll');
                }

            }else{
                if(actionType=='more'){
                    currentDom.attr('data-offset',response.offset);
                }else if(actionType=='scroll'){
                    currentDom.attr('data-offset',response.offset);
                } else{
                    currentDom.attr('data-offset',response.offset);
                    currentDom.css({'display':'none'});
                }
            }
            //alert(response.offset);
        });
    }
    /*************************************************
     * Ajax load more & infinite scroll products end *
     ************************************************/

      /* $(document).ready(function(){

    // $(document).on('click','.qcld_express_product_details',function() {
      
        $('.qcld_express_product_details').magnificPopup({
          type: 'inline',
          preloader: true,
          focus: '#ss',
          modal: true,
          closeOnContentClick: false,
          closeBtnInside: true,
          midClick: true
        });
      

    });
*/
/*
     $(document).on('click','.qcld_express_product_details',function(event) {
        event.preventDefault();

       var slider = $('#image-gallery').lightSlider();

        $.magnificPopup.open({items: {src: '#qcld-express-product-modal'},type: 'inline'}, 0);

        $("#qcld-express-product").html('<h5 style="padding-top: 30px;padding-left:30px;">Loading..</h5>');
          var product_id=$(this).attr('product-id');
          var data = {
            'action':'product_details',
            'product_id':product_id,
          };

        jQuery.post(ajaxurl, data, function (response) {
            $("#qcld-express-product-modal").css({'width':'100vw','height':'100vh'});
            $("#qcld-express-product").html(response);
            //$(".qcld-express-categorie a").attr("href", "#");
            $('.qcld-express-quick-right [rel="tag"]').attr("href", "#");


            $('#image-gallery').lightSlider({
                gallery:true,
                item:1,
                thumbItem:6,
                slideMargin: 0,
                speed:500,
                auto:true,
                loop:true,
                onSliderLoad: function() {
                    $('#image-gallery').removeClass('cS-hidden');
                }
            });


            
        });
    });*/

    //Carousel with slick slider
    /*$('.category-carousel').slick({
            dots: false,
            infinite: false,
            speed: 500,
            slidesToShow: 1,
            centerMode: false,
            variableWidth: true,
            slidesToScroll: 1,
            prevArrow: '<div class="category-carousel-arrow category-carousel-left"><span class="fa fas far fal fab fa-arrow-left"></span></div>',
            nextArrow: '<div class="category-carousel-arrow category-carousel-right"><span class="fa fas far fal fab fa-arrow-right"></span></div>'
        });*/

    //if(qcld_express_show_category_dropdown == 'on'){

        //Now it will not throw error
        $(document).ready(ExpresscreateSlick);
        $(window).resize(ExpresscreateSlick);

   // }

   $(document).on("click", ".qcld-category-toggle-view a.qcld-express-active-category.qcld_all_tab", function (event) {
        event.preventDefault();
        if ($(this).hasClass("qcld-all-active")) {
            $(this).removeClass("qcld-all-active");
            $(".qcld-category-toggle-view a.qcld-express-active-category").not(".qcld_all_tab").css({ display: "none" });
        } else {
            $(this).addClass("qcld-all-active");
            $(".qcld-category-toggle-view a.qcld-express-active-category").css({ display: "block" });
        }
    });

    //$('.slick-slide a.qcld-express-active-category').click(function(){
    $(document).on('click','.qcld-category-toggle-view a.qcld-express-active-category:not(.qcld_all_tab)',function(event) {
        
        if(qcld_express_show_category_dropdown == 'on'){

            $('.qcld-category-toggle-view a.qcld-express-active-category.qcld_all_tab').removeClass("qcld-all-active");
            $(".qcld-category-toggle-view a.qcld-express-active-category").not(".qcld_all_tab").css({ display: "none" });
        
        }


    });                                 
    
    

    function ExpresscreateSlick(){

        var ps = $(".express-shop-wrapper");

        if( ps.outerWidth() > 100 && ps.outerWidth() < 480 ){

            if(qcld_express_show_category_dropdown == 'on'){

                $('.category-carousel').filter('.slick-initialized').slick("unslick");
                $('.category-carousel').addClass("qcld-category-toggle-view");
                $('.qcld-category-toggle-view a.qcld-express-active-category.qcld-express-current').addClass("qcld_all_tab");
                $(".qcld-category-toggle-view a.qcld-express-active-category").not(".qcld-express-current").css({ display: "none" });
                //$(".qcld-category-toggle-view a.qcld-express-active-category").css({ display: "block" });
            }

            // qcld-express-current

        }else{

            $('.category-carousel').not('.slick-initialized').slick({
                dots: false,
                infinite: false,
                speed: 500,
                slidesToShow: 1,
                centerMode: false,
                variableWidth: true,
                slidesToScroll: 1,
                prevArrow: '<div class="category-carousel-arrow category-carousel-left"><span class="fa fas far fal fab fa-arrow-left"></span></div>',
                nextArrow: '<div class="category-carousel-arrow category-carousel-right"><span class="fa fas far fal fab fa-arrow-right"></span></div>'
            });

            if(qcld_express_show_category_dropdown == 'on'){

                $('.category-carousel').removeClass("qcld-category-toggle-view");
            }


        }
            

    }


    /*****************************************
     * Fly cart effect start **
     * *************************************/
    function flyToElement(flyer, flyingTo) {
        var $func = $(this);
        var divider = 3;
        var flyerClone = $(flyer).clone();
        $(flyerClone).css({position: 'absolute', top: $(flyer).offset().top + "px", left: $(flyer).offset().left + "px", opacity: 1, 'z-index': 1000});
        $('body').append($(flyerClone));
        var gotoX = $(flyingTo).offset().left + ($(flyingTo).width() / 2) - ($(flyer).width()/divider)/2;
        var gotoY = $(flyingTo).offset().top + ($(flyingTo).height() / 2) - ($(flyer).height()/divider)/2;

        $(flyerClone).animate({
                opacity: 0.4,
                left: gotoX,
                top: gotoY,
                width: $(flyer).width()/divider,
                height: $(flyer).height()/divider
            }, 700,
            function () {
                $(flyingTo).fadeOut('fast', function () {
                    $(flyingTo).fadeIn('fast', function () {
                        $(flyerClone).fadeOut('fast', function () {
                            $(flyerClone).remove();
                        });
                    });
                });
            });
    }


    /* js add by delowar */

   $(document).ready(function(){
     
        var ps = $(".express-shop-wrapper");

        if( ps.outerWidth() > 667 &&  ps.outerWidth() < 900 ){
            
            $('.qcld-express-sku-cell').css({"max-width": "110px",'padding-left':'5px'});
            $('.qcld-express-title-cell').css({"max-width": "130px"});
            $('.qcld-express-cell').css("padding", "15px 2px");
            $('.qcld-express-sku').css("padding-left", "5px");
            $('.qcld_express_product_details').css("margin-right", "5px");
            
            $('.qcld-express-price-cell').css("max-width", "160px");
            $('.qcld-express-action-cell').css("max-width", "160px");
            $('.qcld-express-desc-cell').css("max-width", "160px");
            $('.qcld-express-title a').css({'font-size': '14px'});
            $('.qcld-express-row.qcld_header button#submit_search').css({
                                                           'height:' : '28px',
                                                           'padding' : '5px 11px',
                                                           'transform' : 'rotate(-90deg) translateY(17px)',
                                                           '-moz-transform' : 'rotate(-90deg) translateY(17px)',
                                                           '-webkit-transform' : 'rotate(-90deg) translateY(17px)',
                                                           '-o-transform' : 'rotate(-90deg) translateY(17px)',
                                                           '-ms-transform' : 'rotate(-90deg) translateY(17px)',
                                                        });

        }else{

            $('.qcld-express-sku-cell').css({"max-width": "",'padding-left':''});
            $('.qcld-express-title-cell').css({"max-width": ""});
            $('.qcld-express-cell').css("padding", "");
            $('.qcld-express-sku').css("padding-left", "");
            $('.qcld_express_product_details').css("margin-right", "");
            
            $('.qcld-express-price-cell').css("max-width", "");
            $('.qcld-express-action-cell').css("max-width", "");
            $('.qcld-express-desc-cell').css("max-width", "");
            $('.qcld-express-title a').css({'font-size': ''});
            $('.qcld-express-row.qcld_header button#submit_search').css({
                                                           'height:' : '',
                                                           'padding' : '',
                                                           'transform' : '',
                                                           '-moz-transform' : '',
                                                           '-webkit-transform' : '',
                                                           '-o-transform' : '',
                                                           '-ms-transform' : '',
                                                        });
        }

    });

    $(window).resize(function() {
        var ps = $(".express-shop-wrapper");

        if( ps.outerWidth() > 667 &&  ps.outerWidth() < 900 ){

            $('.qcld-express-sku-cell').css({"max-width": "110px",'padding-left':'5px'});
            $('.qcld-express-title-cell').css({"max-width": "130px"});
            $('.qcld-express-cell').css("padding", "15px 2px");
            $('.qcld-express-sku').css("padding-left", "5px");
            $('.qcld_express_product_details').css("margin-right", "5px");
            $('.qcld-express-price-cell').css("max-width", "160px");
            $('.qcld-express-action-cell').css("max-width", "160px");
            $('.qcld-express-desc-cell').css("max-width", "160px");
            $('.qcld-express-title a').css({'font-size': '14px'});
            $('.qcld-express-row.qcld_header button#submit_search').css({
                                                   'height:' : '28px',
                                                   'padding' : '5px 11px',
                                                   'transform' : 'rotate(-90deg) translateY(17px)',
                                                   '-moz-transform' : 'rotate(-90deg) translateY(17px)',
                                                   '-webkit-transform' : 'rotate(-90deg) translateY(17px)',
                                                   '-o-transform' : 'rotate(-90deg) translateY(17px)',
                                                   '-ms-transform' : 'rotate(-90deg) translateY(17px)',
                                                });


        }else{


        $('.qcld-express-sku-cell').removeAttr("style");
        $('.qcld-express-title-cell').removeAttr("style");
        $('.qcld-express-cell').removeAttr("style");
        $('.qcld-express-sku').removeAttr("style");
        $('.qcld_express_product_details').removeAttr("style");
        $('.qcld-express-price-cell').removeAttr("style");
        $('.qcld-express-action-cell').css("max-width", "");
        $('.qcld-express-desc-cell').css("max-width", "");
        $('.qcld-express-title a').removeAttr("style");
        $('.qcld-express-row.qcld_header button#submit_search').removeAttr("style");

        }


    });


    function addCssWhenResize(){

        var ps = $(".express-shop-wrapper");

       if( ps.outerWidth() > 667 &&  ps.outerWidth() < 900 ){
            
            $('.qcld-express-sku-cell').css({"max-width": "110px",'padding-left':'5px'});
            $('.qcld-express-title-cell').css({"max-width": "130px"});
            $('.qcld-express-cell').css("padding", "15px 2px");
            $('.qcld-express-sku').css("padding-left", "5px");
            $('.qcld_express_product_details').css("margin-right", "5px");
            
            $('.qcld-express-price-cell').css("max-width", "160px");
            $('.qcld-express-action-cell').css("max-width", "160px");
            $('.qcld-express-desc-cell').css("max-width", "160px");
            $('.qcld-express-title a').css({'font-size': '14px'});
            $('.qcld-express-row.qcld_header button#submit_search').css({
                                                           'height:' : '28px',
                                                           'padding' : '5px 11px',
                                                           'transform' : 'rotate(-90deg) translateY(17px)',
                                                           '-moz-transform' : 'rotate(-90deg) translateY(17px)',
                                                           '-webkit-transform' : 'rotate(-90deg) translateY(17px)',
                                                           '-o-transform' : 'rotate(-90deg) translateY(17px)',
                                                           '-ms-transform' : 'rotate(-90deg) translateY(17px)',
                                                        });

        }else{

            $('.qcld-express-sku-cell').css({"max-width": "",'padding-left':''});
            $('.qcld-express-title-cell').css({"max-width": ""});
            $('.qcld-express-cell').css("padding", "");
            $('.qcld-express-sku').css("padding-left", "");
            $('.qcld_express_product_details').css("margin-right", "");
            
            $('.qcld-express-price-cell').css("max-width", "");
            $('.qcld-express-desc-cell').css("max-width", "");
            $('.qcld-express-action-cell').css("max-width", "");
            $('.qcld-express-title a').css({'font-size': ''});
            $('.qcld-express-row.qcld_header button#submit_search').css({
                                                           'height:' : '',
                                                           'padding' : '',
                                                           'transform' : '',
                                                           '-moz-transform' : '',
                                                           '-webkit-transform' : '',
                                                           '-o-transform' : '',
                                                           '-ms-transform' : '',
                                                        });
        }

    };




    /*****************************************
    // Category Search by ajax
    /*****************************************/
    $(document).on('click','.qcld_express_c_search',function(event) {
        event.preventDefault();
        searchPreloaders('show');
        var currentDom = $(this);
        var cId=$(this).attr('c-id');
        var actionType = "more";
        var offset=currentDom.attr('data-offset');
        var link_title_to_modal = currentDom.attr('title-modal');
        var category_ids=$(this).attr('category_ids'); 
        var audio_feature=$(this).attr('audio_feature'); 
        var video_feature=$(this).attr('video_feature'); 
        var author=$(this).attr('author');

        var data = {
            'action': 'product_search_by_cat',
            'c_id': cId,
            'offset': offset,
            'category_ids': category_ids,
            'link_title_to_modal' : link_title_to_modal,
            'audio_feature' : audio_feature,
            'video_feature' : video_feature,
            'author' : author,
            'security': qcld_express_security_nonce
        };

        jQuery.post(ajaxurl, data, function (response) {

            $(".qcld-express-product-container").html(response.html);
            $(".qcld-express-categorie a").attr("href", "#");
            addCssWhenResize();
            searchPreloaders('hide');

                if(response.hot_deail_according_cat == 'on'){
                    $('.qcld_express_hot_deals_tab').attr('c-id', response.cat_type_id);
                }


                if (response.offset == -1) {
                    if (actionType == 'more') {
                        $('.qcld-express-more-scroll-container').css({'display': 'none'});
                    } else {
                        $('.qcld-express-more-scroll-container').css({'display': 'none'});
                        $(window).unbind('scroll');
                    }
                    // $(window).unbind('scroll');
                } else {
                    if (actionType == 'more') {
                        $('.qcld-express-more-scroll-container').css({'display': 'flex'});
                        $('#qcld-express-more').css({'display': 'flex'});
                        $('#qcld-express-more').attr('data-offset', response.offset);
                        $('#qcld-express-more').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-more').attr('qcld-hot-deal', '');
                        // scroll
                        $('#qcld-express-scroll').css({'display': 'flex'});
                        $('#qcld-express-scroll').attr('data-offset', response.offset);
                        $('#qcld-express-scroll').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-scroll').attr('qcld-hot-deal', '');
                    } else {
                        $('.qcld-express-more-scroll-container').css({'display': 'flex'});
                        $('#qcld-express-more').css({'display': 'flex'});
                        $('#qcld-express-more').attr('data-offset', response.offset);
                        $('#qcld-express-more').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-more').attr('qcld-hot-deal', '');
                        //scroll
                        $('#qcld-express-scroll').css({'display': 'flex'});
                        $('#qcld-express-scroll').attr('data-offset', response.offset);
                        $('#qcld-express-scroll').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-scroll').attr('qcld-hot-deal', '');
                        // currentDom.css({'display': 'none'});
                    }
                }
            

                $('.qcld-express-popup-img').magnificPopup({
                  type: 'image',
                  closeOnContentClick: true,
                  closeBtnInside: false,
                  fixedContentPos: true,
                  mainClass: 'mfp-no-margins mfp-with-zoom',
                  image: {
                    verticalFit: true
                  },
                  zoom: {
                    enabled: true,
                    duration: 300 
                  }
                });

                if( qcld_express_scroll_category_clickable == 'on' ){

                    $('html,body').animate( { scrollTop: $(".qcld-express-slope-wrapper-rights").offset().top}, 300 );

                }


        });
    });

    /*****************************************
    // Hot product Search by ajax
    /*****************************************/
    $(document).on('click','.qcld_express_hot_deals_tab',function(event) {
        event.preventDefault();
        searchPreloaders('show');
        var currentDom = $(this);
        var cId=$(this).attr('c-id');
        var actionType = "more";
        var offset=currentDom.attr('data-offset');
        var link_title_to_modal = currentDom.attr('title-modal');
        var category_ids=$(this).attr('category_ids'); 
        var sorting_val=$(this).attr('qcld-hot-deal'); 
        var author=$(this).attr('author'); 

        var data = {
            'action': 'product_search_by_cat',
            'c_id': cId,
            'offset': offset,
            'category_ids': category_ids,
            'link_title_to_modal' : link_title_to_modal,
            'sorting_val' : sorting_val,
            'author' : author,
            'security': qcld_express_security_nonce
        };

        jQuery.post(ajaxurl, data, function (response) {

            $(".qcld-express-product-container").html(response.html);
            $(".qcld-express-categorie a").attr("href", "#");
            addCssWhenResize();
            searchPreloaders('hide');
            //console.log(response.offset);
            //$('.qcld-express-more-scroll-container').hide();
                if (response.offset == -1) {
                    if (actionType == 'more') {
                        $('.qcld-express-more-scroll-container').css({'display': 'none'});
                    } else {
                        $('.qcld-express-more-scroll-container').css({'display': 'none'});
                        $(window).unbind('scroll');
                    }
                    // $(window).unbind('scroll');
                } else {
                    if (actionType == 'more') {
                        $('.qcld-express-more-scroll-container').css({'display': 'flex'});
                        $('#qcld-express-more').css({'display': 'flex'});
                        $('#qcld-express-more').attr('data-offset', response.offset);
                        $('#qcld-express-more').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-more').attr('qcld-hot-deal', sorting_val);
                        // scroll
                        $('#qcld-express-scroll').css({'display': 'flex'});
                        $('#qcld-express-scroll').attr('data-offset', response.offset);
                        $('#qcld-express-scroll').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-scroll').attr('qcld-hot-deal', sorting_val);
                    } else {
                        $('.qcld-express-more-scroll-container').css({'display': 'flex'});
                        $('#qcld-express-more').css({'display': 'flex'});
                        $('#qcld-express-more').attr('data-offset', response.offset);
                        $('#qcld-express-more').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-more').attr('qcld-hot-deal', sorting_val);
                        //scroll
                        $('#qcld-express-scroll').css({'display': 'flex'});
                        $('#qcld-express-scroll').attr('data-offset', response.offset);
                        $('#qcld-express-scroll').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-scroll').attr('qcld-hot-deal', sorting_val);
                        // currentDom.css({'display': 'none'});
                    }
                }
            


        });
    });


    // All Product search filter show with category name..
    $(document).on('click','.qcld_express_cat_search',function(event) {
        event.preventDefault();
        searchPreloaders('show');
        var currentDom = $(this);
        var cId=currentDom.attr('c-id');
        var actionType = "more";
        var offset=currentDom.attr('data-offset');
        var category_ids=currentDom.attr('category_ids'); 
        var audio_feature=currentDom.attr('audio_feature'); 
        var video_feature=currentDom.attr('video_feature'); 
        var author=currentDom.attr('author'); 

        var data = {
            'action': 'qcld_express_pro_product_search_by_cat_with_cat_name',
            'c_id': cId,
            'category_ids': category_ids,
            'offset': offset,
            'audio_feature': audio_feature,
            'video_feature': video_feature,
            'author': author,
            'security': qcld_express_security_nonce
        };

        jQuery.post(ajaxurl, data, function (response) {
            //console.log(response);

            if(response.hot_deail_according_cat == 'on'){
                $('.qcld_express_hot_deals_tab').attr('c-id', response.cat_type_id);
            }
            $(".qcld-express-product-container").html(response.html);
            addCssWhenResize();
            $('.qcld-express-more-scroll-container').css({'display': 'none'});
            //console.log(response.offset);
          
            searchPreloaders('hide');

        });
    });




    /*****************************************
    // Product show by sku to asc or desc order ..........
    ******************************************/
    $(document).on('click','#sku-sort',function(event) {
        event.preventDefault();
        searchPreloaders('show');
        var skuOrder=$(this).attr('order_by_sku'); 
        var category_ids=$(this).attr('category_ids'); 

        var currentDom = $(this);
        var cId='all';
        var actionType = "more";
        var offset=0;      
        var link_title_to_modal = currentDom.attr('title-modal');
        var audio_feature = currentDom.attr('audio_feature');
        var video_feature = currentDom.attr('video_feature');
        var author = currentDom.attr('author');

        var data = {
            'action': 'product_search_by_cat',
            'skuOrder': skuOrder,
            'c_id': cId,
            'offset': offset,
            'category_ids': category_ids,
            'link_title_to_modal' : link_title_to_modal,
            'audio_feature' : audio_feature,
            'video_feature' : video_feature,
            'author' : author,
            'security': qcld_express_security_nonce
        };

        jQuery.post(ajaxurl, data, function (response) {

            $(".qcld-express-product-container").html(response.html);
            $(".qcld-express-categorie a").attr("href", "#");
            addCssWhenResize();
            searchPreloaders('hide');
           // $('.qcld-express-more-scroll-container').hide();
            $('.slick-slide a.qcld-express-active-category').removeClass("active");

                if (response.offset == -1) {
                    if (actionType == 'more') {
                        $('.qcld-express-more-scroll-container').css({'display': 'none'});
                    } else {
                        $('.qcld-express-more-scroll-container').css({'display': 'none'});
                        $(window).unbind('scroll');
                    }
                    // $(window).unbind('scroll');
                } else {
                    if (actionType == 'more') {
                        $('.qcld-express-more-scroll-container').css({'display': 'flex'});
                        $('#qcld-express-more').css({'display': 'block'});
                        $('#qcld-express-more').attr('data-offset', response.offset);
                        $('#qcld-express-more').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-more').attr('qcld-hot-deal', '');
                    } else {
                        $('.qcld-express-more-scroll-container').css({'display': 'flex'});
                        $('#qcld-express-more').css({'display': 'block'});
                        $('#qcld-express-more').attr('data-offset', response.offset);
                        $('#qcld-express-more').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-more').attr('qcld-hot-deal', '');
                        // currentDom.css({'display': 'none'});
                    }
                }


                $('.qcld-express-popup-img').magnificPopup({
                  type: 'image',
                  closeOnContentClick: true,
                  closeBtnInside: false,
                  fixedContentPos: true,
                  mainClass: 'mfp-no-margins mfp-with-zoom',
                  image: {
                    verticalFit: true
                  },
                  zoom: {
                    enabled: true,
                    duration: 300 
                  }
                });

        });

    });

    /*****************************************
    // Product show  by title to asc or desc order ..........
    ******************************************/
    $(document).on('click','#title-sort',function(event) {
        event.preventDefault();
        searchPreloaders('show');
        var titleOrder=$(this).attr('order_by_title'); 
        var category_ids=$(this).attr('category_ids');       
        
        var currentDom = $(this);
        var cId='all';
        var actionType = "more";
        var offset=0;
        var link_title_to_modal = currentDom.attr('title-modal');
        var audio_feature = currentDom.attr('audio_feature');
        var video_feature = currentDom.attr('video_feature');
        var author = currentDom.attr('author');
        
        var data = {
            'action': 'product_search_by_cat',
            'titleOrder': titleOrder,
            'c_id': cId,
            'offset': offset,
            'category_ids': category_ids,
            'link_title_to_modal' : link_title_to_modal,
            'audio_feature' : audio_feature,
            'video_feature' : video_feature,
            'author' : author,
            'security': qcld_express_security_nonce
        };

        jQuery.post(ajaxurl, data, function (response) {

            $(".qcld-express-product-container").html(response.html);
            $(".qcld-express-categorie a").attr("href", "#");
            addCssWhenResize();
            searchPreloaders('hide');
            $('.slick-slide a.qcld-express-active-category').removeClass("active");


                if (response.offset == -1) {
                    if (actionType == 'more') {
                        $('.qcld-express-more-scroll-container').css({'display': 'none'});
                    } else {
                        $('.qcld-express-more-scroll-container').css({'display': 'none'});
                        $(window).unbind('scroll');
                    }
                    // $(window).unbind('scroll');
                } else {
                    if (actionType == 'more') {
                        $('.qcld-express-more-scroll-container').css({'display': 'flex'});
                        $('#qcld-express-more').css({'display': 'block'});
                        $('#qcld-express-more').attr('data-offset', response.offset);
                        $('#qcld-express-more').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-more').attr('qcld-hot-deal', '');
                    } else {
                        $('.qcld-express-more-scroll-container').css({'display': 'flex'});
                        $('#qcld-express-more').css({'display': 'block'});
                        $('#qcld-express-more').attr('data-offset', response.offset);
                        $('#qcld-express-more').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-more').attr('qcld-hot-deal', '');
                        // currentDom.css({'display': 'none'});
                    }
                }


             $('.qcld-express-popup-img').magnificPopup({
                  type: 'image',
                  closeOnContentClick: true,
                  closeBtnInside: false,
                  fixedContentPos: true,
                  mainClass: 'mfp-no-margins mfp-with-zoom',
                  image: {
                    verticalFit: true
                  },
                  zoom: {
                    enabled: true,
                    duration: 300 
                  }
                });


        });

    });

    /*****************************************
    // Product show  by price to asc or desc order ..........
    ******************************************/
    $(document).on('click','#price-sort',function(event) {
        event.preventDefault();
        searchPreloaders('show');
        var priceOrder=$(this).attr('order_by_price');   
        var category_ids=$(this).attr('category_ids'); 

        var currentDom = $(this);
        var cId='all';
        var actionType = "more";
        var offset=0;     
        var link_title_to_modal = currentDom.attr('title-modal');
        var audio_feature = currentDom.attr('audio_feature');
        var video_feature = currentDom.attr('video_feature');
        var author = currentDom.attr('author');

        var data = {
            'action': 'product_search_by_cat',
            'priceOrder': priceOrder,
            'c_id': cId,
            'offset': offset,
            'category_ids': category_ids,
            'link_title_to_modal' : link_title_to_modal,
            'audio_feature' : audio_feature,
            'video_feature' : video_feature,
            'author' : author,
            'security': qcld_express_security_nonce
        };

        jQuery.post(ajaxurl, data, function (response) {

            $(".qcld-express-product-container").html(response.html);
            $(".qcld-express-categorie a").attr("href", "#");
            addCssWhenResize();
            searchPreloaders('hide');
            // $('.qcld-express-more-scroll-container').hide();
            $('.slick-slide a.qcld-express-active-category').removeClass("active");


                if (response.offset == -1) {
                    if (actionType == 'more') {
                        $('.qcld-express-more-scroll-container').css({'display': 'none'});
                    } else {
                        $('.qcld-express-more-scroll-container').css({'display': 'none'});
                        $(window).unbind('scroll');
                    }
                    // $(window).unbind('scroll');
                } else {
                    if (actionType == 'more') {
                        $('.qcld-express-more-scroll-container').css({'display': 'flex'});
                        $('#qcld-express-more').css({'display': 'block'});
                        $('#qcld-express-more').attr('data-offset', response.offset);
                        $('#qcld-express-more').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-more').attr('qcld-hot-deal', '');
                    } else {
                        $('.qcld-express-more-scroll-container').css({'display': 'flex'});
                        $('#qcld-express-more').css({'display': 'block'});
                        $('#qcld-express-more').attr('data-offset', response.offset);
                        $('#qcld-express-more').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-more').attr('qcld-hot-deal', '');
                        // currentDom.css({'display': 'none'});
                    }
                }

                $('.qcld-express-popup-img').magnificPopup({
                  type: 'image',
                  closeOnContentClick: true,
                  closeBtnInside: false,
                  fixedContentPos: true,
                  mainClass: 'mfp-no-margins mfp-with-zoom',
                  image: {
                    verticalFit: true
                  },
                  zoom: {
                    enabled: true,
                    duration: 300 
                  }
                });

        });

    });

    /*****************************************
    // Product show  by search form ..........
    ******************************************/
    $(document).on('click','#submit_search',function(event) {
        event.preventDefault();
        searchPreloaders('show');
        var sku=$('#qcld_sku').val(); 
        var title=$('#qcld_title').val(); 
        var price_min=$('#qcld_price_min').val(); 
        var price_max=$('#qcld_price_max').val(); 

        var currentDom = $(this);
        var cId='all';
        var actionType = "more";
        var offset=0; 
       // alert(sku); 
        var author = $('#qcld_title').attr('author');     

        var data = {
            'action'    : 'product_search_by_cat',
            'sku'       : sku,
            'title'     : title,
            'price_min' : price_min,
            'price_max' : price_max,
            'c_id': cId,
            'offset': offset,
            'author' : author,
            'security': qcld_express_security_nonce
        };

        jQuery.post(ajaxurl, data, function (response) {

            $(".qcld-express-product-container").html(response.html);
            addCssWhenResize();
            searchPreloaders('hide');
            // $('.qcld-express-more-scroll-container').hide();
            $('.slick-slide a.qcld-express-active-category').removeClass("active");

                if (response.offset == -1) {
                    if (actionType == 'more') {
                        $('.qcld-express-more-scroll-container').css({'display': 'none'});
                    } else {
                        $('.qcld-express-more-scroll-container').css({'display': 'none'});
                        $(window).unbind('scroll');
                    }
                    // $(window).unbind('scroll');
                } else {
                    if (actionType == 'more') {
                        $('.qcld-express-more-scroll-container').css({'display': 'flex'});
                        $('#qcld-express-more').css({'display': 'block'});
                        $('#qcld-express-more').attr('data-offset', response.offset);
                        $('#qcld-express-more').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-more').attr('qcld-hot-deal', '');
                    } else {
                        $('.qcld-express-more-scroll-container').css({'display': 'flex'});
                        $('#qcld-express-more').css({'display': 'block'});
                        $('#qcld-express-more').attr('data-offset', response.offset);
                        $('#qcld-express-more').attr('data-cat', response.cat_type_id);
                        $('#qcld-express-more').attr('qcld-hot-deal', '');
                        // currentDom.css({'display': 'none'});
                    }
                }

                 $('.qcld-express-popup-img').magnificPopup({
                  type: 'image',
                  closeOnContentClick: true,
                  closeBtnInside: false,
                  fixedContentPos: true,
                  mainClass: 'mfp-no-margins mfp-with-zoom',
                  image: {
                    verticalFit: true
                  },
                  zoom: {
                    enabled: true,
                    duration: 300 
                  }
                });

        });

    });

    $(document).on('keypress','#qcld_sku,#qcld_title,#qcld_price_min,#qcld_price_max',function(event) {
        if(event.which === 13){
            $('#submit_search').trigger('click');
        }
    });

    // Preloader function here..
    function searchPreloaders(val) {

        show = function(){
            
            $('body').prepend('<div class="before-loading"><div class="spin" id="spin3"></div></div>');
            //setTimeout(hide, 3000); 
        },

        hide = function(){
            $('.before-loading').hide();
        };

        if(val == 'show'){
            show();
        }else{
            hide();
        }
               

    };

    // category active class add and remove..
    $(document).ready(function(){
        //$('.slick-slide a.qcld-express-active-category').click(function(){
        $(document).on('click','.slick-slide a.qcld-express-active-category',function(event) {
            $('.slick-slide a.qcld-express-active-category').removeClass("active");
            $(this).addClass("active");

        });
    });


    $(document).ready(function(){

    $('.qcld-express-popup-img').magnificPopup({
          type: 'image',
          closeOnContentClick: true,
          closeBtnInside: false,
          fixedContentPos: true,
          mainClass: 'mfp-no-margins mfp-with-zoom',
          image: {
            verticalFit: true
          },
          zoom: {
            enabled: true,
            duration: 300 
          }
        });
    });



    $(document).ready(function() {

        var $window = $(window);
        var $addclasss = $('.qc-left-side-item-list .is_stickyed');

        function resize() {
            if ($window.width() < 960) {
               $addclasss.addClass('category-carousel');

               return $addclasss.slick({
                    dots: false,
                    infinite: false,
                    speed: 500,
                    slidesToShow: 1,
                    centerMode: false,
                    variableWidth: true,
                    slidesToScroll: 1,
                    prevArrow: '<div class="category-carousel-arrow category-carousel-left"><span class="fa fa-long-arrow-left"></span></div>',
                    nextArrow: '<div class="category-carousel-arrow category-carousel-right"><span class="fa fa-long-arrow-right"></span></div>'
                });
            }else{

                $addclasss.removeClass('category-carousel');
                
            }

        }

        $window.resize(resize).trigger('resize');

    });


    $(document).on('click','.qcld-express-active-category',function(event) {
        $('.qcld-express-active-category').removeClass("qcld-express-current");
        $(this).addClass("qcld-express-current");
    });


    $(document).on('keyup', '.qcld_express_search_products input[type="text"]', function(e) {

        var results = $('.qcld-express-live-search-results'),
        form = $('.qcld_express_search_products'),
        click = false,
        request = false;

       // results.hide();
        $('.qcld-express-live-search-results').hide();

        title = $(this).val();
        //alert(title);
        var author = $(this).attr('author');

        if (title.length < 2) {
            $('.qcld_express_search_products').removeClass('loading');
            return;
        }


        request && request.abort();

        request = $.ajax({
            url: ajaxurl,
            method: 'POST',
            data: {
                'action': 'qcld_express_pro_shop_ajax_search',
                's': title,
                'author' : author,
                'security': qcld_express_security_nonce
            },
            dataType: 'json',
            beforeSend: function() {

                $('.qcld_express_search_products').addClass('loading');
                results.hide();
            },
            complete: function() {
                  
                $('.qcld_express_search_products').removeClass('loading');
                results.on('click', '.view-all a', function(e) {
                    e.preventDefault();
                    $('.qcld_express_search_products').parents('form').trigger('submit');
                });
                //click = true;
            },
            success: function(response) {
                $('.qcld-express-live-search-results').remove();
                $('.qcld_express_search_products').append('<div class="qcld-express-live-search-results"></div>');
                $('.qcld-express-live-search-results').html(response.html).show();
            },
            error: function() {}
        });
        

    });

    $('body').on('click', function(event) {
        if (!$(event.target).is('.qcld-express-search-form-wrapper') && $(event.target).closest('.qcld-express-search-form-wrapper').length) return;
        $('.qcld-express-live-search-results').hide();
    });


    $(document).on("click", ".qcld-express-search-single", function(event) {
        
        var p_id = $(this).attr('p-id');
        var author = $(this).attr('author');
        var data = {
            'action' : 'qcld_express_pro_search_product_single_view',
            'p_id'   : p_id,
            'search_type' : 1,
            'author' : author,
            'security': qcld_express_security_nonce
        };

        jQuery.post(ajaxurl, data, function (response) {
            $(".qcld-express-product-container").html(response.html);
            $(".qcld-express-categorie a").attr("href", "#");
           
        });


    });



    $(document).on('keyup click','.qcld-express-simple-p-qnty',function(event) {
        var quantity = $(this).val();
        var change_value = $(this).parent().parent().find('.ajax_add_to_cart');
        var change_values = $(this).parent().parent().find('.qcld_express_s_p');
        $(change_value).attr('data-quantity', quantity);
        $(change_values).attr('data-quantity', quantity);
    });


    // Video Modal
    $(document).on('click','.qcld_express_video_modal',function(event) {
        event.preventDefault();
        $("#qcld-express-video-product").html('');

        $.magnificPopup.open({items: {src: '#qcld-express-video-modal'},type: 'inline'}, 0);

          var video_type = $(this).attr('video-type');
          var video_host = $(this).attr('video-host');
          var video_url = $(this).attr('video-url');

          var data = {
            'action':'qcld_express_pro_video_info',
            'video_type':video_type,
            'video_host':video_host,
            'video_url':video_url,
            'security': qcld_express_security_nonce
          };

        jQuery.post(ajaxurl, data, function (response) {
            $("#qcld-express-video-modal").css({'width':'100vw','height':'100vh'});
            $("#qcld-express-video-product").html(response);
            
        });
    });

    // Video Modal
    // $(document).on('click','#qcld-express-video-modal .mfp-close',function(event) {
    //     event.preventDefault();
    //     $("#qcld-express-video-product").html('');
    // });

    /*$(document).on('click','.mfp-close',function(event) {
        event.preventDefault();

        alert('modal close');

        $('.qcld_express_video_iframe').each(function(index) {
            $(this).attr('src', $(this).attr('src'));
            return false;
        });

    });*/

        var qcld_video = document.getElementsByClassName("qcld_express_video_iframe");
        function qcld_stopVid(){
          qcld_video.pause();
          qcld_video.currentTime = 0;
        }

        //attach event handler to close button

        $(".mfp-close").on('click', function(){
            qcld_stopVid();
        });


       // $('input.qcld-express-simple-p-qnty').before('<input class="qcld_express_minus" type="button" value="-">');
        //$('input.qcld-express-simple-p-qnty').after('<input class="qcld_express_plus" type="button" value="+">');


        $(document).on('click', '.qcld_express_plus', function (e) {

            $input = $(this).prev('input.qcld-express-simple-p-qnty');
            var val = parseInt($input.val());
            var step_val = parseInt($input.attr('step')) ? parseInt($input.attr('step')) : 1;
            $input.val(val + step_val).change();

            ///qcld-express-action

            var change_value = $(this).closest('.qcld-express-action').find('.ajax_add_to_cart');
            var change_values = $(this).closest('.qcld-express-action').find('.qcld_express_s_p');
            $(change_value).attr('data-quantity', $input.val());
            $(change_values).attr('data-quantity', $input.val());

        });

        $(document).on('click', '.qcld_express_minus', function (e) {

            $input = $(this).next('input.qcld-express-simple-p-qnty');
            var val = parseInt($input.val());
            var step_val = parseInt($input.attr('step')) ? parseInt($input.attr('step')) : 1;
            var min_val = parseInt($input.attr('min')) ? parseInt($input.attr('min')) : 0;
            if (val > min_val) {
                $input.val(val - step_val).change();


                var change_value = $(this).closest('.qcld-express-action').find('.ajax_add_to_cart');
                var change_values = $(this).closest('.qcld-express-action').find('.qcld_express_s_p');
                $(change_value).attr('data-quantity', $input.val());
                $(change_values).attr('data-quantity', $input.val());
            
            }



        });

        $(document).on('click','.qcld_express_plus, .qcld_express_minus',function(event) {

            $(this).parent().find('.qc_product_quantity').trigger('keyup');

        });

        $(document).on('click','html, body',function(event) {

            setTimeout(function(){ 

                triggerForPlusMiusBtn();

                // triggerForPlusMiusquickView();

                if(qcld_express_plus_minus_icon_qty == 'on'){
                    
                    triggerForPlusMiusquickView();
                    
                }

            }, 3000);

        });

        triggerForPlusMiusBtn();

        function triggerForPlusMiusBtn(){

            $('input.qcld_express_minus').remove();
            $('input.qcld_express_plus').remove();


            var CurrentDom = $('input.qcld-express-simple-p-qnty');
            var CheckDomPlus = $('input.qcld-express-simple-p-qnty').closest('.qcld-express-action').find('.qcld_express_plus').length;
            var CheckDomMinus = $('input.qcld-express-simple-p-qnty').closest('.qcld-express-action').find('.qcld_express_minus').length;

            CurrentDom.closest('.qcld-express-action-cell').removeClass('qcld_express_plus_minus_wrap');

            if( CheckDomPlus > 0 || CheckDomMinus > 0 ){
                return;
            }

            CurrentDom.closest('.qcld-express-action-cell').addClass('qcld_express_plus_minus_wrap');

            $(CurrentDom).before('<input class="qcld_express_minus" type="button" value="-">');
            $(CurrentDom).after('<input class="qcld_express_plus" type="button" value="+">');


        }


        if(qcld_express_plus_minus_icon_qty == 'on'){
            
            triggerForPlusMiusquickView();
            
        }

        function triggerForPlusMiusquickView(){

            $('input.qcld_express_quick_plus').remove();
            $('input.qcld_express_quick_minus').remove();

            var CurrentDom = $('input.input-text.qty');
            var CheckDomPlus = $('input.input-text.qty').closest('.product-quantity').find('.qcld_express_quick_plus').length;
            var CheckDomMinus = $('input.input-text.qty').closest('.product-quantity').find('.qcld_express_quick_minus').length;


            if( CheckDomPlus > 0 || CheckDomMinus > 0 ){
                return;
            }

            $(CurrentDom).before('<input class="qcld_express_quick_minus" type="button" value="-">');
            $(CurrentDom).after('<input class="qcld_express_quick_plus" type="button" value="+">');


        }



        $(document).on('click', '.qcld_express_quick_plus', function (e) {

            $input = $(this).prev('input.input-text.qty');
            var val = parseInt($input.val());
            var step_val = parseInt($input.attr('step')) ? parseInt($input.attr('step')) : 1;
            $input.val(val + step_val).change();

        });

        $(document).on('click', '.qcld_express_quick_minus', function (e) {

            $input = $(this).next('input.input-text.qty');
            var val = parseInt($input.val());
            var step_val = parseInt($input.attr('step')) ? parseInt($input.attr('step')) : 1;
            var min_val = parseInt($input.attr('min')) ? parseInt($input.attr('min')) : 0;
            if (val > min_val) {
                $input.val(val - step_val).change();
            
            }


        });





        $('.qc-left-side-item-list ul.qcld_express_children li a').click(function () {
            var tab_id = $(this).attr('data-tab');

            $('.qc-wootabs-main ul.qc-wootabs-nav li').removeClass('current');
            $('.tab-content').removeClass('current');

            $(this).addClass('current');
            $("#" + tab_id).addClass('current');
        })


    // for sidebar catelog template dropdown menu...
    $(document).ready(ExpresscreateSidebarCatelogTem);
    $(window).resize(ExpresscreateSidebarCatelogTem);

    $(document).on('click','.qc-left-side-item-list a.qcld-express-active-category',function(event) {
        
        if(qcld_express_show_catelog_dropdown == 'on'){

            var qcld_side_drop_tab = $(this);

            var check_wrap = qcld_side_drop_tab.closest('.qcld_express_children').length;

            if(check_wrap == 0){
                $(".qc-left-side-item-list ul.qcld_express_children").css({ display: "none" });
            }

            qcld_side_drop_tab.closest('.qcld_side_dropdown_tab').find('.qcld_express_children').css({ display: "block" });
        
        }


    });                                 
    
    

    function ExpresscreateSidebarCatelogTem(){

        var ps = $(".express-shop-wrapper");

        if(qcld_express_show_catelog_dropdown == 'on'){

            $('.qc-left-side-item-list a.qcld-express-active-category').parent().find('.qcld_express_children').parent().addClass("qcld_side_dropdown_tab");
            $(".qc-left-side-item-list ul.qcld_express_children").css({ display: "none" });
        }
        
    }

    //window.addEventListener('popstate', function(){alert(1);});

   /*  $(window).unload(function(e){    
        e.preventDefault();
        $(window).trigger('popstate ');      

    });    */

    /*$(window).bind('popstate ',function(){

   //your ajax call here 
        alert('working')
    });*/
   


});


