<?php
define('express_shop_LICENSING_PLUGIN_SLUG', 'express-shop-pro/qcld-express.php');
define('express_shop_LICENSING_PLUGIN_NAME', 'express-shop-pro');
define('express_shop_LICENSING__DIR', plugin_dir_path(__DIR__));

define('express_shop_LICENSING_REMOTE_PATH', 'https://www.ultrawebmedia.com/li/plugins/express-shop-pro/update.php');
define('express_shop_LICENSING_PRODUCT_DEV_URL', 'https://quantumcloud.com/products/');

//start new-update-for-codecanyon
define('express_shop_ENVATO_PLUGIN_ID', 22374782);
//end new-update-for-codecanyon

function get_express_shop_licensing_plugin_data(){
	include_once(ABSPATH.'wp-admin/includes/plugin.php');
	return get_plugin_data(express_shop_LICENSING__DIR.'/qcld-express.php', false);
}

//License Options
function get_express_shop_licensing_key(){
	return get_option('qcld_express_shop_enter_license_key');
}

function get_express_shop_envato_key(){
	return get_option('qcld_express_shop_enter_envato_key');
}

function get_express_shop_licensing_buy_from(){
	return get_option('qcld_express_shop_buy_from_where');
}


//Update Transients
function get_express_shop_update_transient(){
	return get_transient('qcld_update_express_shop');
}

function set_express_shop_update_transient($plugin_object){
	return set_transient( 'qcld_update_express_shop', serialize($plugin_object), 1 * DAY_IN_SECONDS  );
}

function delete_express_shop_update_transient(){
	return delete_transient( 'qcld_update_express_shop' );
}


//Renewal Transients
function get_express_shop_renew_transient(){
	return get_transient('qcld_renew_express_shop_subscription');
}

function set_express_shop_renew_transient($plugin_object){
	return set_transient( 'qcld_renew_express_shop_subscription', serialize($plugin_object), 1 * DAY_IN_SECONDS  );
}

function delete_express_shop_renew_transient(){
	return delete_transient( 'qcld_renew_express_shop_subscription' );
}


//Invalid License Options
function get_express_shop_invalid_license(){
	return get_option('express_shop_invalid_license');
}

function set_express_shop_invalid_license(){
	return update_option('express_shop_invalid_license', 1);
}

function delete_express_shop_invalid_license(){
	return delete_option('express_shop_invalid_license');
}
function express_shop_get_licensing_url(){
	return admin_url('edit.php?post_type=pd&page=qcld_express_shop_help_license');
}

//Valid License
function get_express_shop_valid_license(){
	return get_option('express_shop_valid_license');
}
function set_express_shop_valid_license(){
	return update_option('express_shop_valid_license', 1);
}
function delete_express_shop_valid_license(){
	return delete_option('express_shop_valid_license');
}

//staging or live 
function get_express_shop_site_type(){
	return get_option('qcld_express_shop_site_type');
}



//start new-update-for-codecanyon
function get_express_shop_license_purchase_code(){
	return get_option('qcld_express_shop_enter_license_or_purchase_key');
}

function get_express_shop_enter_license_notice_dismiss_transient(){
	return get_transient('get_express_shop_enter_license_notice_dismiss_transient');
}

function set_express_shop_enter_license_notice_dismiss_transient(){
	return set_transient('get_express_shop_enter_license_notice_dismiss_transient', 1, DAY_IN_SECONDS);
}

function get_express_shop_invalid_license_notice_dismiss_transient(){
	return get_transient('get_express_shop_invalid_license_notice_dismiss_transient');
}

function set_express_shop_invalid_license_notice_dismiss_transient(){
	return set_transient('get_express_shop_invalid_license_notice_dismiss_transient', 1, DAY_IN_SECONDS);
}
//end new-update-for-codecanyon