<!--Adding Template Specific Style -->
<?php

wp_enqueue_style( 'qcld_express_gradient_style',QCLD_EXPRESS_TEMPLATE_URL ."/$qcld_express_template/style.css");

//loading top cart part.
if(file_exists(QCLD_EXPRESS_TEMPLATES . "/qcld-express-template-top.php")){
    require (QCLD_EXPRESS_TEMPLATES . "/qcld-express-template-top.php" );
}
?>
<style type="text/css">
  .express-shop-wrapper .qcld-express-current,.qcld_hot-deals-tab li:before {
    background:<?php echo $qcld_express_active_menu_bg; ?> !important;
    color:<?php echo $qcld_express_active_menu_color; ?> !important;
  }

  .qcld_hot-deals-tab {
    <?php if(isset($qcld_express_hot_deals_menu_bg_color) && $qcld_express_hot_deals_menu_bg_color != '' ):
        echo 'background: '.$qcld_express_hot_deals_menu_bg_color.' !important';
      else:
        echo 'background: #d1d1f5 !important';
      endif; 
      ?>
  }
  .qcld_hot-deals-tab li{
    color:<?php echo $qcld_express_hot_deals_menu_button_fonts_color; ?> !important;
    background: <?php echo $qcld_express_hot_deals_menu_button_bg_color; ?> !important;
  }
  .qcld_hot-deals-tab li:hover{
    color:<?php echo $qcld_express_active_menu_color; ?> !important;
  }
</style>
  <?php if(isset($qcld_express_hot_deals_product_tab) && $qcld_express_hot_deals_product_tab == 'on' ): ?>
  <ul class="qcld_hot-deals-tab">                              
    <li class="qcld-express-active-category qcld_express_hot_deals_tab " qcld-hot-deal="price" c-id="all" category_ids="<?php echo $category_ids_perameter; ?>" audio_feature="<?php echo $qcld_express_audio_feature_product; ?>" video_feature="<?php echo $qcld_express_video_feature_product; ?>" title-modal="<?php echo $link_title_to_modal; ?>" data-offset="<?php echo $offset; ?>" author="<?php echo $dokan_get_current_user_id; ?>"><?php echo $qcld_express_lang_hot_deals_hot; ?></li>
    <li class="qcld-express-active-category qcld_express_hot_deals_tab " qcld-hot-deal="date" c-id="all" category_ids="<?php echo $category_ids_perameter; ?>" audio_feature="<?php echo $qcld_express_audio_feature_product; ?>" video_feature="<?php echo $qcld_express_video_feature_product; ?>" title-modal="<?php echo $link_title_to_modal; ?>" data-offset="<?php echo $offset; ?>" author="<?php echo $dokan_get_current_user_id; ?>"><?php echo $qcld_express_lang_hot_deals_new; ?></li>
    <li class="qcld-express-active-category qcld_express_hot_deals_tab " qcld-hot-deal="rating" c-id="all" category_ids="<?php echo $category_ids_perameter; ?>" audio_feature="<?php echo $qcld_express_audio_feature_product; ?>" video_feature="<?php echo $qcld_express_video_feature_product; ?>" title-modal="<?php echo $link_title_to_modal; ?>" data-offset="<?php echo $offset; ?>" author="<?php echo $dokan_get_current_user_id; ?>"><?php echo $qcld_express_lang_hot_deals_best_buy; ?></li>
    <li class="qcld-express-active-category qcld_express_hot_deals_tab " qcld-hot-deal="popularity" c-id="all" category_ids="<?php echo $category_ids_perameter; ?>" audio_feature="<?php echo $qcld_express_audio_feature_product; ?>" video_feature="<?php echo $qcld_express_video_feature_product; ?>" title-modal="<?php echo $link_title_to_modal; ?>" data-offset="<?php echo $offset; ?>" author="<?php echo $dokan_get_current_user_id; ?>"><?php echo $qcld_express_lang_hot_deals_featured; ?></li>
  </ul>
  <?php endif; ?>
  <form method="get" action="<?php echo get_the_permalink(); ?>">
  <div class="qcld-express-table qcld-express-product-container">
    <div class="qcld-express-row qcld_header">
      <?php
      //Sku show or not
      if(isset($qcld_express_sku) && $qcld_express_sku=='on' ){
       ?>
      <div class="qcld-express-cell qcld-express-sku-cell">
        <p class="qcld-express-sku-heading">  <a id="sku-sort" category_ids="<?php echo $category_ids_perameter; ?>" audio_feature="<?php echo $qcld_express_audio_feature_product; ?>" video_feature="<?php echo $qcld_express_video_feature_product; ?>" title-modal="<?php echo $link_title_to_modal; ?>" order_by_sku="sku_ASC" href="#"> 
      <?php 
        if($qcld_express_lang_sku == ''){
          echo 'SKU';
        }else{
          echo $qcld_express_lang_sku;
        }
      ?>
      </a> </p>
      <?php if(!isset($_GET['category'] )){

            if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){
        ?>
          <input type="text" name="sku" id="qcld_sku"  placeholder="<?php echo $qcld_express_lang_sku_placeholder; ?>">
          <?php } } ?>
      </div>
        <?php }
        //Image thumnail show or not
        if(isset($qcld_express_thumbnail) && $qcld_express_thumbnail=='on' ){
        ?>
      <div class="qcld-express-cell qcld-express-thumb-cell">
          <p class="qcld-express-thumbnail-heading">
            <?php 
              if($qcld_express_lang_thumbnail == ''){
                echo 'Thumbnail';
              }else{
                echo $qcld_express_lang_thumbnail;
              }
            ?>

          </p>
      </div>
      <?php }
      //Title show or not
      if(isset($qcld_express_title) && $qcld_express_title=='on' ){
      ?>
      <div class="qcld-express-cell qcld-express-title-cell">
          <p class="qcld-express-title-heading"> <a id="title-sort" category_ids="<?php echo $category_ids_perameter; ?>" audio_feature="<?php echo $qcld_express_audio_feature_product; ?>" video_feature="<?php echo $qcld_express_video_feature_product; ?>" title-modal="<?php echo $link_title_to_modal; ?>" order_by_title="title_ASC" href="#">
             <?php 
              if($qcld_express_lang_title == ''){
                echo 'Product';
              }else{
                echo $qcld_express_lang_title;
              }
            ?>
          </a> </p>
          <?php if(!isset($_GET['category'] )){

            if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){
            ?>

              <div class="qcld-express-search-form-wrapper">
                <form method="get" class="qcld_express_searchform" action="<?php echo esc_url( home_url( '/'  ) ) ?>" role="search">
                    <div class="qcld_express_search_products">
                        <input type="text" value="" name="title" id="qcld_title" class="search-field" placeholder="<?php echo $qcld_express_lang_title_placeholder; ?>" autocomplete="off" />
                    </div>
                </form>
              </div>
          <?php } } ?>
      </div>
      <?php }
      //Description show or not
      if(isset($qcld_express_description) && $qcld_express_description=='on' ){
      ?>
      <div class="qcld-express-cell qcld-express-desc-cell">
          <p class="qcld-express-desc-heading"> 
            <?php 
              if($qcld_express_lang_desc == ''){
                echo 'Description';
              }else{
                echo $qcld_express_lang_desc;
              }
            ?>

          </p>
      </div>
      <?php }
      //Tag show or not
      if(isset($qcld_express_tag) && $qcld_express_tag == 'on' ){
      ?>
      <div class="qcld-express-cell qcld-express-audio-cell">
          <p class="qcld-express-audio-heading"> 
            <?php 
              if($qcld_express_tag_lang == ''){
                echo 'Tag';
              }else{
                echo $qcld_express_tag_lang;
              }
            ?>

          </p>
      </div>
      <?php }
      
     

      //Audio show or not
      if(isset($qcld_express_audio_feature_product) && $qcld_express_audio_feature_product=='on' ){
       ?>
      <div class="qcld-express-cell qcld-express-audio-cell">
        <p class="qcld-express-audio-heading"> <?php echo 'Audio'; ?> </p>
      </div>
      <?php }
      
      //Video show or not
      if(isset($qcld_express_video_feature_product) && $qcld_express_video_feature_product=='on' ){
       ?>
      <div class="qcld-express-cell qcld-express-video-cell">
        <p class="qcld-express-video-heading"> <?php echo 'Video'; ?> </p>
      </div>
      <?php }

      //Availability show or not
      if(isset($qcld_express_stock) && $qcld_express_stock=='on' ){
      ?>
    <div class="qcld-express-cell qcld-express-avail-cell">
          <p class="qcld-express-avail-heading">
             <?php 
              if($qcld_express_lang_availability == ''){
                echo 'Availability';
              }else{
                echo $qcld_express_lang_availability;
              }
            ?>

          </p>
      </div>
      <?php }
      //Price show or not
      if(isset($qcld_express_price) && $qcld_express_price=='on' ){
      ?>
    <div class="qcld-express-cell qcld-express-price-cell">
          <p class="qcld-express-price-heading"><a id="price-sort" category_ids="<?php echo $category_ids_perameter; ?>" audio_feature="<?php echo $qcld_express_audio_feature_product; ?>" video_feature="<?php echo $qcld_express_video_feature_product; ?>" title-modal="<?php echo $link_title_to_modal; ?>"  order_by_price="price_ASC" href="#">

             <?php 
              if($qcld_express_lang_price == ''){
                echo 'Price';
              }else{
                echo $qcld_express_lang_price;
              }
            ?>
          </a> </p>
          <?php if(!isset($_GET['category'] )){

            if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){
            ?>
          <input type="number" name="price_min" id="qcld_price_min" placeholder="<?php echo $qcld_express_lang_from; ?>" min="0" > - <input type="number" min="0" name="price_max" id="qcld_price_max" placeholder="<?php echo $qcld_express_lang_to; ?>" >
          <?php } } ?>
      </div>
      <?php }
      // Action show or not
      if(isset($qcld_express_action) && $qcld_express_action=='on' ){
      ?>
    <div class="qcld-express-cell qcld-express-action-cell">
          <p class="qcld-express-action-heading">
           
          </p>
          <?php if(!isset($_GET['category'] )){

            if(isset($qcld_express_hide_search_option) && $qcld_express_hide_search_option != 'on'){
            ?>
          <button type="button" id="submit_search">
            <?php 
              if($qcld_express_lang_search == ''){
                echo 'Search';
              }else{
                echo $qcld_express_lang_search;
              }
            ?>
          </button>
          <?php } } ?>
      </div>
      <?php } ?>
    </div>

    <?php
    //Creating WooCommerce product factory.
    $wc_pf = new WC_Product_Factory();
    //repeating the products
    if ($product_query->have_posts()) :
     //foreach($products as $P){
    while ($product_query->have_posts()) : $product_query->the_post();
         $product = $wc_pf->get_product(get_the_ID());
         //Checking for image thumb.
         $qcld_thumb = wp_get_attachment_image_src( get_post_thumbnail_id( get_the_ID() ), 'shop_thumbnail' );
         $qcld_large = wp_get_attachment_image_src( get_post_thumbnail_id( get_the_ID() ), 'single-post-thumbnail' );
         if(!empty($qcld_thumb)){
             $image =$qcld_thumb;
             $image_large =$qcld_large;
         }else{
             $image[0] =QCLD_EXPRESS_IMG_URL.'/placeholder.png';
             $image_large[0]=QCLD_EXPRESS_IMG_URL.'/placeholder.png';
         }

          $qcld_express_audio_title     =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_audio_title', true ));
          $qcld_express_audio_url       =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_audio_url', true ));
          $qcld_express_audio_ogg_url   =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_audio_ogg_url', true ));

          $qcld_express_video_name      =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_video_name', true ));
          $qcld_express_video_type      =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_video_type', true ));
          $qcld_express_video_host      =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_video_host', true ));
          $qcld_express_video_url       =   unserialize( get_post_meta( get_the_ID(), 'qcld_express_video_url', true ));
         ?>
    <div class="qcld-express-row">
     <?php
    //Sku show or not
     if(isset($qcld_express_sku) && $qcld_express_sku=='on' ){
     ?>
      <div class="qcld-express-cell qcld-express-sku-cell">
          <p class="qcld-express-sku"> <?php echo $product->get_sku(); ?></p>
      </div>
     <?php }
     //Image thumnail show or not
     if(isset($qcld_express_thumbnail) && $qcld_express_thumbnail=='on' ){
     ?>
      <div class="qcld-express-cell qcld-express-thumb-cell">
          <p class="qcld-express-thumbnail"> <a href="<?php echo $image_large[0];?>" class="qcld-express-popup-img">
              <img class="qlcd-express-list-thumb" src="<?php  echo $image[0]; ?>"  alt=" <?php  echo get_the_title(get_the_ID()); ?>"/>
              </a></p>
      </div>
     <?php }
     //Title show or not
     if(isset($qcld_express_title) && $qcld_express_title=='on' ){
     ?>
      <div class="qcld-express-cell qcld-express-title-cell">
          <h3 class="qcld-express-title">
            <?php    
            if(isset($link_title_to_modal) && ($link_title_to_modal == '1' || $link_title_to_modal == '01')){
            ?> 
              <a href="#" class="qcld_express_product_details" product-id="<?php echo get_the_ID() ?>">
            <?php }else{ ?>
              <a href="<?php echo get_the_permalink(); ?>" product-id="<?php echo get_the_ID() ?>">
            <?php } ?>
              <?php  echo get_the_title(get_the_ID()); ?>
              </a> 
              
              <?php 
                if(isset($qcld_express_category_show_above_tite) && $qcld_express_category_show_above_tite == 'on' ){
              ?>
                <p class="qcld-express-categorie"><?php echo wc_get_product_category_list(get_the_ID()) ?></p>
              <?php } ?>

            </h3>

      </div>
     <?php }
     //Description show or not
     if(isset($qcld_express_description) && $qcld_express_description=='on' ){
     ?>
      <div class="qcld-express-cell qcld-express-desc-cell">
          <p class="qcld-express-desc"><?php  echo strip_tags(substr(get_the_excerpt(get_the_ID()),0,$qcld_express_short_description_set_character).' ... ');
            if(isset($qcld_express_details_button) && $qcld_express_details_button == 'on' ){
          ?> 
              
              <a href="#" class="qcld_express_product_details" product-id="<?php echo get_the_ID() ?>">
                  <i class="fa fa-info-circle" aria-hidden="true"></i>
              </a>
            <?php } ?>

            </p>
      </div>
     <?php }


      //Tag show or not
     if(isset($qcld_express_tag) && $qcld_express_tag == 'on' ){
     ?>
    <div class="qcld-express-cell qcld-express-desc-cell">
          <p class="qcld-express-desc">
            <?php 

            $qcld_output = array();

            $qcld_terms = wp_get_post_terms( get_the_id(), 'product_tag' );

            if( count($qcld_terms) > 0 ){
                foreach($qcld_terms as $term){
                    $term_id = $term->term_id;
                    $term_name = $term->name;
                    $term_slug = $term->slug;
                    $term_link = get_term_link( $term, 'product_tag' );

                    $qcld_output[] = '<a href="'.$term_link.'">'.$term_name.'</a>';
                }
                $qcld_output = implode( ', ', $qcld_output );

                echo $qcld_output;
            }


            ?>
          </p>
      </div>
     <?php }




    // Audio show or not
     if(isset($qcld_express_audio_feature_product) && $qcld_express_audio_feature_product == 'on' ){
     ?>
      <div class="qcld-express-cell qcld-express-audio-cell">

        <?php 
        $audio_not_available = QCLD_EXPRESS_IMG_URL.'/audio-not-available.png';
           
        if( !empty( $qcld_express_audio_url ) ){
        ?>
            <?php foreach( $qcld_express_audio_url as $index => $audio_url ){
              if(isset($audio_url) && !empty($audio_url)){
                $qcld_express_audio_title = isset($qcld_express_audio_title[$index]) ? $qcld_express_audio_title[$index] : '';
                $qcld_express_audio_ogg_url = isset($qcld_express_audio_ogg_url[$index]) ? $qcld_express_audio_ogg_url[$index] : '';
              ?>
        <div class="qcld_express_container">
        <div class="qcld_express_audio-player">
          <div class="qcld_express_buttons"> <span>
            <button type="button" class="qcld_express_prev"></button>
            <button type="button" class="qcld_express_play" title="<?php echo esc_attr($qcld_express_audio_title); ?>"></button>
            <button type="button" class="qcld_express_pause" title="<?php echo esc_attr($qcld_express_audio_title); ?>"></button>
            <button type="button" class="qcld_express_stop"></button>
            <button type="button" class="qcld_express_next"></button>
            </span> </div>
          <div class="clearfix"></div>
          <div class="qcld_express_tracker">
            <div class="qcld_express_progress-bar"> <span class="qcld_express_progress"></span> </div>
            <span class="qcld_express_duration">0:00</span> </div>
          <div class="clearfix"></div>
          <ul class="qcld_express_playlist qcld_express_hidden">
            <li song="<?php echo esc_url( $audio_url ); ?>" ogg_song="<?php echo esc_url( $qcld_express_audio_ogg_url ); ?>" cover="cover1.jpg" artist="Linkin Park"><?php echo esc_url( $audio_url ); ?></li>

          </ul>
        </div>
      </div>
            <?php } } ?>
        <?php }else{ ?>
          <div class="qcld_express_container">
            <div class="qcld_express_audio-player">
              <img src="<?php echo esc_url( $audio_not_available ); ?>">
            </div>
          </div>
        <?php } ?>

      </div>
     <?php }

    // Video show or not
     if(isset($qcld_express_video_feature_product) && $qcld_express_video_feature_product == 'on' ){
     ?>
      <div class="qcld-express-cell qcld-express-video-cell">

        <?php 
        $video_img = QCLD_EXPRESS_IMG_URL.'/video-track.png';
        $audio_not_available = QCLD_EXPRESS_IMG_URL.'/audio-not-available.png';
           
        if( !empty( $qcld_express_video_name ) ){ ?>
          <?php foreach( $qcld_express_video_name as $index => $video_name ){  

            if(isset($video_name) &&  !empty( $video_name ) ){
                $qcld_express_video_type = isset($qcld_express_video_type[$index]) ? $qcld_express_video_type[$index] : '';
                $qcld_express_video_url = isset($qcld_express_video_url[$index]) ? $qcld_express_video_url[$index] : '';
                $qcld_express_video_host = isset($qcld_express_video_host[$index]) ? $qcld_express_video_host[$index] : '';

          ?>
        <div class="qcld_express_container">
        <div class="qcld_express_audio-player">

          <a href="#" class="qcld_express_video_modal" video-type="<?php echo $qcld_express_video_type; ?>" video-host="<?php echo $qcld_express_video_host; ?>" video-url="<?php echo $qcld_express_video_url; ?>" ><img src="<?php echo esc_url( $video_img ); ?>" alt="<?php echo esc_attr( $video_name ); ?>" title="<?php echo esc_attr( $video_name ); ?>"></a>
        </div>
      </div>
          <?php }  } ?>
        <?php }else{ ?>
          <div class="qcld_express_container">
            <div class="qcld_express_audio-player">
              <img src="<?php echo esc_url( $audio_not_available ); ?>">
            </div>
          </div>
        <?php } ?>

      </div>
     <?php }

     //Availability show or not
     if(isset($qcld_express_stock) && $qcld_express_stock=='on' ){
     ?>
      <div class="qcld-express-cell qcld-express-avail-cell">
          <p class="qcld-express-avail">
                <?php
                  $stock = get_post_meta( get_the_ID(), '_stock', true );
                  $stock_status = get_post_meta( get_the_ID(), '_stock_status', true );
                  if($stock>0){ ?>
                  <span class="qcld-express-avail-in"> <?php  echo $qcld_express_lang_in_stock; ?> (<?php  echo $product->get_stock_quantity(); ?>)</span>
                <?php   } else if($stock==""){?>
                    <?php if( $stock_status == "instock" ){ ?>
                      <span class="qcld-express-avail-out"> <?php  echo $qcld_express_lang_in_stock; ?> </span>
                    <?php } else if( $stock_status == "outofstock" ){ ?>
                      <span class="qcld-express-avail-out"> <?php  echo $qcld_express_lang_out_of_stock; ?> </span>
                    <?php } ?>
                <?php } else if($stock<1){ ?>
                      <span class="qcld-express-avail-out"> <?php  echo $qcld_express_lang_out_of_stock; ?></span>
                <?php } ?>
          </p>
      </div>
     <?php }
     //Price show or not
     if(isset($qcld_express_price) && $qcld_express_price=='on' ){
     ?>
      <div class="qcld-express-cell qcld-express-price-cell">
          <p class="qcld-express-price"><?php echo $product->get_price_html() ?></p>
      </div>
     <?php }
     // Action show or not
     if(isset($qcld_express_action) && $qcld_express_action=='on' ){
     ?>
      <div class="qcld-express-cell qcld-express-action-cell">
          <ul class="qcld-express-action">
         <?php

         if($product->get_type() == 'external'){

          $link = sprintf( '<a rel="nofollow" href="%s" data-quantity="%s" data-product_id="%s" data-product_sku="%s" class="%s" target="_blank">%s</a>',
                  esc_url( $product->add_to_cart_url() ),
                  esc_attr( isset( $quantity ) ? $quantity : 1 ),
                  esc_attr( get_the_ID() ),
                  esc_attr( $product->get_sku() ),
                  esc_attr( isset( $class ) ? $class : 'qcld_product_type_external' ),
                  esc_html( $product->add_to_cart_text() )
                  );
          echo $link;

          }else if($product->get_type()=='variable' ){
            if($qcld_express_variable_product_show_tooltip == 'on'){
            ?>
            <li> <a class="qcld_express_v_p_tooltip" p-id="<?php echo get_the_ID() ?>"><i class="fa fa-shopping-cart"></i></a></li>
           <?php 
         }else{
          ?>
          <li> <a class="qcld_express_v_p" p-id="<?php echo get_the_ID() ?>"><i class="fa fa-shopping-cart"></i></a></li>
          <?php
         } 
       }else{

         

                $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                    $response_min_max = qcld_express_pro_add_rules_text(get_the_ID(),0);

                    $min_qty  = $response_min_max['min'];
                    $max_qty  = $response_min_max['max'];
                    $step_qty = $response_min_max['step'];
        
        
        ?>
              <li><input type="number" value="<?php echo ($min_qty ? $min_qty : 1); ?>" step="<?php echo ($step_qty ? $step_qty : ''); ?>" min="<?php echo ($min_qty ? $min_qty : ''); ?>" max="<?php echo ($max_qty ? $max_qty : ''); ?>" name="qcld_quantity" class="qcld-express-simple-p-qnty"></li>
      <?php }else{ ?>
        <li><input type="number" value="1" name="qcld_quantity" class="qcld-express-simple-p-qnty"></li>
      <?php } ?>
                <?php
                  $stock = get_post_meta( get_the_ID(), '_stock', true );
                  $stock_status = get_post_meta( get_the_ID(), '_stock_status', true );
                  if( $stock > 0 ){ 
                      if (isset($qcld_express_cart_mode) && $qcld_express_cart_mode == 'wooinstants') {

                         $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                            $response_min_max = qcld_express_pro_add_rules_text(get_the_ID(),0);
                            $min_qty  = $response_min_max['min'];
                          }else{
                            $min_qty  = 1;

                          }
                      ?>
                      <li><a href="#" class="ajax_add_to_cart add_to_cart_button product_type_simple" data-quantity="<?php echo ($min_qty ? $min_qty : 1); ?>" data-product_id="<?php echo get_the_ID() ?>" p-id="<?php echo get_the_ID() ?>" p-price="<?php echo $product->get_price(); ?>" ><i class="fa fa-shopping-cart"></i></a></li>
                      <?php }else{ ?>
                      <li><a href="#" class="qcld_express_s_p" p-id="<?php echo get_the_ID() ?>" p-price="<?php echo $product->get_price(); ?>" ><i class="fa fa-shopping-cart"></i></a></li>
                      <?php } ?>
                <?php } else if( $stock == "" ){ ?>
                    <?php if( $stock_status == "instock" ){ 
                      if (isset($qcld_express_cart_mode) && $qcld_express_cart_mode == 'wooinstants') {

                         $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                            $response_min_max = qcld_express_pro_add_rules_text(get_the_ID(),0);
                            $min_qty  = $response_min_max['min'];
                          }else{
                            $min_qty  = 1;

                          }
                      ?>
                      <li><a href="#" class="ajax_add_to_cart add_to_cart_button product_type_simple"  data-quantity="<?php echo ($min_qty ? $min_qty : 1); ?>" data-product_id="<?php echo get_the_ID() ?>" p-id="<?php echo get_the_ID() ?>" p-price="<?php echo $product->get_price(); ?>" ><i class="fa fa-shopping-cart"></i></a></li>
                      <?php }else{ ?>
                      <li><a href="#" class="qcld_express_s_p" p-id="<?php echo get_the_ID() ?>" p-price="<?php echo $product->get_price(); ?>" ><i class="fa fa-shopping-cart"></i></a></li>
                      <?php } ?>
                    <?php } else if( $stock_status == "outofstock" ){ ?>
                      <li><a href="#" class="qcld_express_s_ps qcld_express_out_of_pro" p-id="<?php echo get_the_ID() ?>" p-price="<?php echo $product->get_price(); ?>" ><i class="fa fa-shopping-cart"></i></a></li>
                    <?php } ?>
                <?php }else if( $stock < 1 ){ ?>
                      <li><a href="#" class="qcld_express_s_ps qcld_express_out_of_pro" p-id="<?php echo get_the_ID() ?>" p-price="<?php echo $product->get_price(); ?>" ><i class="fa fa-shopping-cart"></i></a></li>
                <?php } ?>
                
              <?php } ?>
              <!-- <li> <a href="" data-fancybox data-src="#qcld-express-product-modal"  class="qcld_express_product_details" product-id="<?php echo get_the_ID() ?>">
                  <i class="fa fa-search"></i>
              </a> </li> -->
          </ul>

          

          <?php

            $qcld_woo_minmax_dynamic_pricing_setting = get_option('qcld_woo_minmax_dynamic_pricing_setting');

            if(function_exists('qcld_woo_minmax_install') && (isset($qcld_woo_minmax_dynamic_pricing_setting['qcld_woo_minmax_price_table_on_off']) && $qcld_woo_minmax_dynamic_pricing_setting['qcld_woo_minmax_price_table_on_off'] == 'enable') ){

              $result_show = qcld_express_pro_dynamic_discount_price_table_show(get_the_ID());
              echo $result_show;
            }

              ?>


      </div>
     <?php }//End of show or not ?>
    </div>
    <?php endwhile; ?>
        <?php wp_reset_postdata(); ?>
    <?php else: ?>
        <p class="qcld-express-no-products">
            <?php _e('No Products'); ?>
        </p>
    <?php endif; ?>
  </div>
  </form>
</div>