

jQuery(document).ready(function($) {

    "use strict";

    //Handling the Show product mode.
    if($('input[type=radio][name="qcld_express_options[qcld_express_show_mode]"]:checked').val()=='all'){
        $("#setting_qcld_express_product_per_page").css({'display':'none'});
    }
    $('input[type=radio][name="qcld_express_options[qcld_express_show_mode]"]').change(function() {
        if (this.value == 'more'|| this.value == 'scroll' ) {
            $("#setting_qcld_express_product_per_page").css({'display':'block'});
        }
        else{
            $("#setting_qcld_express_product_per_page").css({'display':'none'});
        }
    });


    // $('#qcld_express_template').change(function(event){
    $(document).on('change','#qcld_express_template',function(event) {
        event.preventDefault();

        var removePrevious = $(this).parent().find('.qcld_express_note');
                
        if( $(this).val()=='slope'){
            removePrevious.hide();
            $(this).after('<span class="qcld_express_note" style="color:red">Standard Product Table with Category Filters on the Left</span>');

        }else if( $(this).val()=='catalog'){
           removePrevious.hide();
            $(this).after('<span class="qcld_express_note" style="color:red">Category wise Product Table. Shows All Products without pagination or load more</span>');

        }else{
            removePrevious.hide();
            $(this).after('<span class="qcld_express_note" style="color:red">Standard Product Table with Category Filters on Top</span>');
        }
	
    });


});



    jQuery(document).ready(function($) {

       // "use strict";

          var  block_params = {
                    message: null,
                    overlayCSS: {
                        background: '#000',
                        opacity: 0.6
                    },
                    ignoreIfBlocked: true
                    },
                    video_file_frame,image_file_frame;

        $('.qcld_express_insert_track').on('click', function(e){
        //$(document).on('click','.qcld_express_insert_track', function(e){
          e.preventDefault();

          //console.log($(this));

            var create_uniqueId = function() {
                return 'id-' + Math.random().toString(36).substr(2, 16);
            }

            current_dom = $(this).closest('.qcld_express_form_audio_container');
            //current_dom = $(this).parent().parent().parent().find('.qcld_express_form_audio_container');

            var audio_container      = $('#qcld_express_audio_data'),
                track_title_field    = current_dom.find('#qcld_express_audio_name'),
                track_url_field      = current_dom.find('#qcld_express_audio_url'),
                ogg_track_url_field  = current_dom.find('#qcld_express_audio_ogg_url'),
                track_title          = track_title_field.val(),
                track_url            = track_url_field.val(),
                ogg_track_url        = ogg_track_url_field.val(),
                is_error             = false;

            if( track_title == '' ){
               track_title_field.addClass('error_field');
                is_error = true;
            }

            if( track_url == '' ){

                track_url_field.addClass('error_field');
                is_error = true
            }

            if( !is_error ){

                audio_container.block( block_params );
                var all_audio_content = $( '.product_audio .qcld_express_woocommerce_audio_data'),
                    content_id = 'qcld_express_audio_'+create_uniqueId(),
                    size = all_audio_content.size(),
                    data = {

                        audio_name : track_title,
                        audio_content : encodeURI( track_url ),
                        ogg_audio_url : encodeURI(ogg_track_url),
                        audio_id: content_id,
                        product_id :woocommerce_admin_meta_boxes.post_id,
                        loop : size,
                        action: qcld_ajax.actions.add_new_audio_row
                    };


                $.ajax({
                    type: 'POST',
                    url: qcld_ajax.admin_url,
                    data: data,
                    dataType: 'json',
                    success: function (response) {
                        // console.log(response);
                        $( '.product_audio' ).append(response.result);
                        audio_container.unblock();
                        track_title_field.val('');
                        track_url_field.val('');
                        ogg_track_url_field.val('');
                        $('body').trigger('qcld_express_new_content_insert',[content_id, track_title]);
                        $('body').trigger('qcld_express_featured_insert');

                    }
                });

            }


        });
        
        $(document).on('click','.qcld_express_delete_audio', function(e){

            e.preventDefault();
            var t = $(this),
                row = t.parent().parent(),
                audio_id = row.find('.qcld_express_audio_id').val();

            row.remove();

            $('body').trigger('qcld_express_remove_content',[audio_id])
        });



        $(document).on('qcld_express_new_content_insert', function(ev,content_id,content_name ) {

            var select_metaboxes = $('.qcld_express_select_featured_content'),
                select_field = $('.select_featured');

            select_metaboxes.block(block_params);

            select_field.append('<option value="'+content_id+'">'+content_name+'</option>');

            setTimeout( function(){  select_metaboxes.unblock();}, 500 );
        });

        $(document).on('qcld_express_featured_insert',function(ev){

            $('input').removeClass('error_field');
            $('select').removeClass('error_field');
            $('textarea').removeClass('erorr_field');

        });


        $(document).on('qcld_express_remove_content', function(ev, content_id){
            var select_metaboxes = $('.qcld_express_select_featured_content'),
                select_field = $('.select_featured');

            select_metaboxes.block(block_params);

            select_field.find('option[value="'+content_id+'"]').remove();
            setTimeout( function(){  select_metaboxes.unblock();}, 500 );
        });


        $(document).on('click','.qcld_express_upload_image_button', function (e) {

            var t = $(this);
            e.preventDefault();

            var downloadable_file_states = [
                // Main states.
                new wp.media.controller.Library({
                    library: wp.media.query({type: 'audio'}),
                    multiple: false,
                    title: t.data('choose'),
                    priority: 20,
                    filterable: 'all'
                })
            ];

            // Create the media frame.
            image_file_frame = wp.media.frames.downloadable_file = wp.media({
                // Set the title of the modal.
                title: t.data('choose'),
                library: {
                    type: 'audio'
                },
                button: {
                    text: t.data('choose')
                },
                multiple: false,
                states: downloadable_file_states
            });

            // When an image is selected, run a callback.
            image_file_frame.on('select', function () {

                var file_path = '',file_id='',
                    selection = image_file_frame.state().get('selection');

                selection.map(function (attachment) {

                    attachment = attachment.toJSON();

                    if (attachment.url) {
                        file_path = attachment.url;
                        file_id = attachment.id;

                        t.parent().find('.qcld_express_audio_url').val(file_path);
                        t.find('.qcld_express_thumbn').attr('src', file_path);
                    }

                });


            });

            // Finally, open the modal.
            image_file_frame.open();
        });


        $(document).on('click','.qcld_express_audio_ogg_button', function (e) {

            var t = $(this);
            e.preventDefault();

            var downloadable_file_states = [
                // Main states.
                new wp.media.controller.Library({
                    library: wp.media.query({type: 'audio'}),
                    multiple: false,
                    title: t.data('choose'),
                    priority: 20,
                    filterable: 'all'
                })
            ];

            // Create the media frame.
            image_file_frame = wp.media.frames.downloadable_file = wp.media({
                // Set the title of the modal.
                title: t.data('choose'),
                library: {
                    type: 'audio'
                },
                button: {
                    text: t.data('choose')
                },
                multiple: false,
                states: downloadable_file_states
            });

            // When an image is selected, run a callback.
            image_file_frame.on('select', function(){

                var file_path = '',file_id='',
                    selection = image_file_frame.state().get('selection');

                selection.map(function (attachment) {

                    attachment = attachment.toJSON();

                    if (attachment.url) {
                        file_path = attachment.url;
                        file_id = attachment.id;

                        t.parent().find('.qcld_express_audio_ogg_url').val(file_path);
                        t.find('.qcld_express_thumbn').attr('src', file_path);
                    }

                });


            });

            // Finally, open the modal.
            image_file_frame.open();
        });




            var select_add_video_by = $( '#qcld_express_video_add_by'),
            button_add_video = $('.qcld_express_add_video'),
            button_remove_video = $('.qcld_express_delete' );


        $(document).on('change','#qcld_express_video_add_by', function (e) {

            var t = $(this),
                selected = t.val(),
                container = t.parents('#qcld_express_form_container'),
                video_id = container.find('.video_add_by_id'),
                video_url = container.find('.video_add_by_url'),
                video_emb = container.find('.video_add_by_embedded'),
                video_up = container.find('.video_add_by_upload'),
                video_host = container.find('.video_type_host'),
                video_name = container.find( '.video_name'),
                button = container.find('.qcld_express_add_video');

            if (t.hasClass('error_field'))
                t.removeClass('error_field');

            video_name.show();
            switch( selected ) {

                case 'id' :
                    video_id.show();
                    video_url.hide();
                    video_emb.hide();
                    video_up.hide();
                    video_host.show();
                    button.show();
                    break;
                case 'url':
                    video_id.hide();
                    video_url.show();
                    video_emb.hide();
                    video_up.hide();
                    video_host.show();
                    button.show();
                    break;
                case 'embd':
                    video_id.hide();
                    video_url.hide();
                    video_emb.show();
                    video_up.hide();
                    video_host.hide();
                    button.show();
                    break;
                case 'upload':
                    video_id.hide();
                    video_url.hide();
                    video_emb.hide();
                    video_up.show();
                    video_host.hide();
                    button.show();
                    break;
                default :
                    video_id.hide();
                    video_url.hide();
                    video_emb.hide();
                    video_up.hide();
                    video_host.hide();
                    video_name.hide();
                    button.hide();
                    break;
            }
        });

        $(document).on('click','.qcld_express_add_video', function (e) {

        //button_add_video.on('click',function(e){

            var video_by            = $( '#qcld_express_video_add_by').val(),
                form_field          = '',
                form_value          = '',
                is_error            = false,
                form_name_field     = $('#qcld_express_video_name'),
                form_name_value     = form_name_field.val();

            var select_add_video_by = $( '#qcld_express_video_add_by');


            if( video_by == '' ){
                select_add_video_by.addClass('error_field');
                e.preventDefault();
                return;
            }

            if( form_name_value == '' ){

                form_name_field.addClass('error_field');
                e.preventDefault();
                return;
            }




            switch( video_by ){

                case 'id' :
                    form_field = $('#qcld_express_video_add_by_id');
                    form_value = form_field.val();
                    if( '' == form_value )
                        is_error = true;
                        break;
                case 'url':
                    form_field = $('#qcld_express_video_add_by_url');
                    form_value = form_field.val();


                    var current_dom  = $(this).closest('.qcld_express_form_container');
                    var video_type_host = current_dom.find('#qcld_express_video_type_host').val();

                        if (video_type_host == 'vimeo'){
                            var regExp = /^.*(vimeo\.com\/)((channels\/[A-z]+\/)|(groups\/[A-z]+\/videos\/))?([0-9]+)/;
                            var match = form_value.match(regExp);
                            if (match){
                                form_value = match[5];
                            }

                        }else{

                            var regId = /^.*(youtu.be\/|v\/|u\/\w\/|embed\/|watch\?v=|\&v=)([^#\&\?]*).*/;
                            var match = form_value.match(regId);
                            if(match && match[2].length === 11) {
                                form_value = match[2];
                            } else {
                                form_value = null;
                            }
                        }

                        break;

                    if( '' == form_value )
                        is_error = true;
                    break;
                case 'embd':
                    form_field = $('#qcld_express_video_add_by_embedded');
                    form_value = encodeURI(form_field.val());
                    if( '' == form_value )
                        is_error = true;
                    break;
                case 'upload':
                    form_field = $('#qcld_express_video_id_up');
                    form_value = form_field.val();
                    if( '' == form_value )
                        is_error = true;
                    break;

            }

           

            if( is_error ){

                form_field.parent().addClass( 'error_field' );
                e.preventDefault();

            }else{

                var  create_uniqueId = function() {
                    return 'id-' + Math.random().toString(36).substr(2, 16);
                 };

                var  video_container = $( '#qcld_express_video_data');

                video_container.block(block_params);

                var all_video_content = $( '.product_video .qcld_express_woocommerce_video'),
                current_dom           = $(this).closest('.qcld_express_form_container'),
                content_id            = 'qcld_express_video_'+create_uniqueId(),
                video_type_field      = current_dom.find('#qcld_express_video_add_by'),
                video_name_field      = current_dom.find('#qcld_express_video_name'),
                video_type_host_field = current_dom.find('#qcld_express_video_type_host'),
                video_url_up_field    = current_dom.find('#qcld_express_video_url_up'),
                video_type            = video_type_field.val(),
                video_name            = video_name_field.val(),
                video_host            = video_type_host_field.val(),
                //video_url_up          = video_url_up_field.val(),
                video_url_up          = form_value,
                size                  = all_video_content.size(),
                data = {
                    video_type : video_type,
                    video_name : video_name,
                    video_content : video_url_up,
                    video_id: content_id,
                    video_host: video_host,
                    product_id :woocommerce_admin_meta_boxes.post_id,
                    loop : size,
                    action: qcld_ajax.actions.add_new_video_row
                };

                

                $.ajax({
                    type: 'POST',
                    url: qcld_ajax.admin_url,
                    data: data,
                    dataType: 'json',
                    success: function (response) {

                        $( '.product_video' ).append(response.result);

                        setTimeout( function(){  video_container.unblock();}, 500 );
                    }
                });

                $('body').trigger('qcld_express_video_row_insert');

                }


            
        });





        //delete a video
        $( document).on( 'click', '.qcld_express_delete', function (e) {
        e.preventDefault();
        var t = $(this),
            row = t.parent().parent(),
            video_id = row.find('.qcld_express_video_id').val();

            row.remove();

         $('body').trigger('qcld_express_remove_content',[video_id])
        });



    //when a new row video is addedd, clear form
    $(document).on('qcld_express_video_row_insert', function (ev) {

        $('#qcld_express_video_add_by').val('').change();
        $('#qcld_express_video_add_by_id').val('');
        $('#qcld_express_video_add_by_url').val('');
        $('#qcld_express_video_add_by_embedded').val('');
        $('#qcld_express_video_name').val('');
        $('#qcld_express_video_url_up').val('');
        $('#qcld_express_video_id_up').val('');
        $('.qcld_express_video_url_up').val('');
    });

    $(document).on('qcld_express_featured_insert',function(ev){

        $('input').removeClass('error_field');
        $('select').removeClass('error_field');
        $('textarea').removeClass('erorr_field');

    } );

    $(document).on('qcld_express_new_content_insert', function(ev,content_id,content_name ) {

        var select_metaboxes = $('.qcld_express_select_featured_content'),
            select_field = $('.select_featured');

        select_metaboxes.block(block_params);

        select_field.append('<option value="'+content_id+'">'+content_name+'</option>');

        setTimeout( function(){  select_metaboxes.unblock();}, 500 );
    });

    $(document).on('qcld_express_remove_content', function(ev, content_id){
        var select_metaboxes = $('.qcld_express_select_featured_content'),
            select_field = $('.select_featured');

        select_metaboxes.block(block_params);

        select_field.find('option[value="'+content_id+'"]').remove();
        setTimeout( function(){  select_metaboxes.unblock();}, 500 );
    });

    //Open MediaLibray for add a Video in product
    $( document).on( 'click', '#qcld_express_video_add_by_upload', function (e) {
        var t = $(this),
            button = $('.qcld_express_add_video');

        e.preventDefault();
        // If the media frame already exists, reopen it.
        if (video_file_frame) {
            video_file_frame.open();
            return;
        }

        var downloadable_file_states = [
            // Main states.
            new wp.media.controller.Library({
                library: wp.media.query({type: 'video'}),
                multiple: false,
                title: t.data('choose'),
                priority: 20,
                filterable: 'uploaded'
            })
        ];

        // Create the media frame.
        video_file_frame = wp.media.frames.downloadable_file = wp.media({
            // Set the title of the modal.
            title: t.data('choose'),
            library: {
                type: 'video'
            },
            button: {
                text: t.data('choose')
            },
            multiple: false,
            states: downloadable_file_states
        });

        // When an image is selected, run a callback.
        video_file_frame.on('select', function () {

            var file_path = '',
                file_id = '',
                selection = video_file_frame.state().get('selection');

            selection.map(function (attachment) {

                attachment = attachment.toJSON();

                if( attachment.type!='video' ){

                    alert(qcld_ajax.error_video);
                    return;
                }

                if (attachment.url) {
                    file_path = attachment.url;
                    file_id = attachment.id;
                }

            });

            var video_path_field = $(document).find('#qcld_express_video_url_up'),
                video_id_field = $(document).find('#qcld_express_video_id_up');


            video_id_field.val(file_id);
            video_path_field.val(file_path);
            button.click();

        });

        // Finally, open the modal.
        video_file_frame.open();

    });




});


