<?php
defined('ABSPATH') or die("No direct script access!");
/**
 * 
 */


		function qcld_express_shop_help_license_callback(){
?>
			<div id="wrap">
				<div id="licensing">
						<h1>Please Insert your license Key</h1>
					<div class="qcld-express_shop-section-block">
						<?php if( get_express_shop_valid_license() ){ ?>
							<div class="qcld-success-notice">
								<p>Thank you, Your License is active</p>
							</div>
						<?php } ?>

						<?php
						
							$track_domain_request = wp_remote_get(express_shop_LICENSING_PRODUCT_DEV_URL."wp-json/qc-domain-tracker/v1/getdomain/?license_key=".get_express_shop_licensing_key());
							if( !is_wp_error( $track_domain_request ) || wp_remote_retrieve_response_code( $track_domain_request ) === 200 ){
								$track_domain_result = json_decode($track_domain_request['body']);
								
								if( !empty($track_domain_result) ){
									$max_domain_num = $track_domain_result[0]->max_domain + 1;
									$total_domains = json_decode($track_domain_result[0]->domain, true);
									$total_domains_num = count($total_domains);

									if( $max_domain_num <= $total_domains_num){
								?>
										<div class="qcld-error-notice">
											<p>You have activated this key for maximum number of sites allowed by your license. Please <a href='https://www.quantumcloud.com/products/'>purchase additional license.</a></p>
										</div>
								<?php
									}
								}
								
							}
						?>
						
						<form onsubmit="return false" id="qc-license-form" method="post" action="options.php">
							<?php
								delete_express_shop_update_transient();
								delete_express_shop_renew_transient();
								
								delete_option('_site_transient_update_plugins');
								settings_fields( 'qcld_express_shop_license' );
								do_settings_sections( 'qcld_express_shop_license' );

								// if( isset($_POST['submit']) ){
								// 	echo 'qcld_express_shop_buy_from_where '.$_POST['qcld_express_shop_buy_from_where'];
								// }
							?>
							<table class="form-table">

								<tr id="quantumcloud_portfolio_license_row" style="display: none">
									<th>
										<label for="qcld_express_shop_enter_license_key"><?php  esc_html_e( 'Enter License Key:', 'express-shop-pro' ); ?></label>
									</th>
									<td>
										<input type="<?php echo (get_express_shop_licensing_key()!=''?'password':'text'); ?>" id="qcld_express_shop_enter_license_key" name="qcld_express_shop_enter_license_key" class="regular-text" value="<?php echo get_express_shop_licensing_key(); ?>">
										<p><?php  esc_html_e( 'You can copy the license key from', 'express-shop-pro' ); ?> <a target="_blank" href='<?php echo esc_url('https://www.quantumcloud.com/products/account/'); ?>'> <?php  esc_html_e( 'your account', 'express-shop-pro' ); ?></a></p>
									</td>
								</tr>

								<tr id="show_envato_plugin_downloader" style="display: none">
									<th>
										<label for="qcld_express_shop_enter_envato_key"><?php  esc_html_e( 'Enter Purchase Code:', 'express-shop-pro' ); ?></label>
									</th>
									<td colspan="4">
										<input type="<?php echo (get_express_shop_envato_key()!=''?'password':'text'); ?>" id="qcld_express_shop_enter_envato_key" name="qcld_express_shop_enter_envato_key" class="regular-text" value="<?php echo get_express_shop_envato_key(); ?>">
										<p> <?php  esc_html_e( 'You can install the', 'express-shop-pro' ); ?><a target="_blank" href="<?php echo esc_url('https://envato.com/market-plugin/'); ?>"> <?php  esc_html_e( 'Envato Plugin', 'express-shop-pro' ); ?></a> <?php  esc_html_e( 'to stay up to date.', 'express-shop-pro' ); ?></p>
									</td>
								</tr>

							<!-- //start new-update-for-codecanyon -->
			                    <tr>
			                        <th>
			                            <label for="qcld_express_shop_enter_license_or_purchase_key"><?php  esc_html_e( 'Enter License Key or Purchase Code:', 'express-shop-pro' ); ?></label>
			                        </th>
			                        <td>
			                            <input type="<?php echo (get_express_shop_license_purchase_code()!=''?'password':'text'); ?>" id="qcld_express_shop_enter_license_or_purchase_key" name="qcld_express_shop_enter_license_or_purchase_key" class="regular-text" value="<?php echo get_express_shop_license_purchase_code(); ?>" required>
			                        </td>
			                    </tr>
			                <!-- //end new-update-for-codecanyon -->

							</table>

							<!-- //start new-update-for-codecanyon -->
			                <input type="hidden" name="qcld_express_shop_buy_from_where" value="<?php echo get_express_shop_licensing_buy_from(); ?>" >
			                <!-- //end new-update-for-codecanyon -->
							<?php submit_button(); ?>
						</form>
					</div>

					
					<div id="setting_qcld_express_help" class="format-settings">
						<div class="format-setting-wrap">
							<div class="format-setting-label">
								<h3 class="label"><?php  esc_html_e( 'Help', 'express-shop-pro' ); ?></h3>
							</div>
							<div class="format-setting type-textblock wide-desc">
                    			<div class="description">
                    				<div>
										<h3><?php  esc_html_e( 'Paste the Following Express Shop Shortcode on Any Page', 'express-shop-pro' ); ?></h3>
										<p><i><?php  esc_html_e( 'Example:', 'express-shop-pro' ); ?></i></p>
			                            <div class="ep-shortcode-list">
			                                <div> <code> [qcld_express_shop]</code> </div>
			                                <div> <code> [qcld_express_shop style="01"]</code> ( ex: style="template number" ) </div>
			                                <div> <code> [qcld_express_shop style="01" link_title_to_modal="1"]</code> <?php  esc_html_e( '( ex: link_title_to_modal="0" | "0" = Disabled or "1" = Enabled )' ); ?></div>
			                                <div> <code> [qcld_express_shop style="01" category_ids="78,102,39,98"]</code>  <?php  esc_html_e( '( ex: category_ids="Category Id" )', 'express-shop-pro' ); ?></div>
			                                <div> <code> [qcld_express_shop style="01" link_title_to_modal="1" category_ids="78,102,39,98"]</code>  <?php  esc_html_e( '( ex: If you want to show all feature by attribute )', 'express-shop-pro' ); ?></div>
			                            </div>
		                            </div>
                        		</div>
                    		</div>
                    	</div>
                    </div>

                    <div id="setting_qcld_express_helps" class="format-settings">
                    	<div class="format-setting-wrap">
                    		<div class="format-setting-label">
                    			<h3 class="label"><?php  esc_html_e( 'Open Close Hours', 'express-shop-pro' ); ?></h3>
                    		</div>
                    		<div class="format-setting type-textblock wide-desc">
                    			<div class="description">
                    				<div>
			                            <h3><?php  esc_html_e( 'Show Opening and Closing Hours', 'express-shop-pro' ); ?></h3>
			                            <p><?php  esc_html_e( 'Enable Opening and Closing Hours from General Settings', 'express-shop-pro' ); ?></p>
			                            <h3>Set Id<?php  esc_html_e( 'Open Close Hours', 'express-shop-pro' ); ?></h3>
			                            <p><?php  esc_html_e( 'Opening and Closing Hours post id value insert Opening and Closing Hours (Set id) Field to General settings', 'express-shop-pro' ); ?></p>
			                            <h3><?php  esc_html_e( 'Redirect to the same page', 'express-shop-pro' ); ?></h3>
			                            <p><?php  esc_html_e( 'Please make sure to Enable AJAX add to cart buttons on Archive for one page shopping experience', 'express-shop-pro' ); ?></p>
                        			</div>
                    			</div>
                    		</div>
                    	</div>
                    </div>

					<script type="text/javascript">
				        jQuery(document).ready(function(){

				            //start new-update-for-codecanyon
				            jQuery('#qcld_express_shop_enter_license_or_purchase_key').on('focusout', function(){
				            	qc_express_shop_set_plugin_license_fields();
				            });

				            jQuery('#qcld_express_shop_enter_license_or_purchase_key').on('keypress',function (e) {
				            	  qc_express_shop_set_plugin_license_fields();
							});

							jQuery('#qc-license-form input[type="submit"]').on('click', function(){
								qc_express_shop_set_plugin_license_fields();
								jQuery('#qc-license-form').removeAttr('onsubmit').submit();
							});

				            function qc_express_shop_set_plugin_license_fields(){
				                var license_input = jQuery('#qcld_express_shop_enter_license_or_purchase_key').val();
				                if( /^(\w{8})-((\w{4})-){3}(\w{12})$/.test(license_input) ){
				                    jQuery('input[name="qcld_express_shop_buy_from_where"]').val('codecanyon');
				                    jQuery('input[name="qcld_express_shop_enter_envato_key"]').val(license_input);
				                }else{
				                    jQuery('input[name="qcld_express_shop_buy_from_where"]').val('quantumcloud');
				                    jQuery('input[name="qcld_express_shop_enter_license_key"]').val(license_input);
				                }
				            }
				            //end new-update-for-codecanyon

				        });
				    </script>
				</div>
			</div>
<?php
		}
	
