<?php 
defined('ABSPATH') or die("No direct script access!");

add_action('wp_ajax_product_details', 'qcld_express_pro_product_details');
add_action('wp_ajax_nopriv_product_details', 'qcld_express_pro_product_details');

function qcld_express_pro_product_details(){
   // wp_enqueue_script( 'jquery', 'wp-util');
    $qcld_express_options                       = get_option('qcld_express_options');

    $qcld_express_lightbox_add_to_cart_button   = $qcld_express_options['qcld_express_lightbox_add_to_cart_button'];
    $qcld_express_lang_category   = $qcld_express_options['qcld_express_lang_category'];

    if(isset($qcld_express_options['qcld_express_lang_out_of_stock']) && $qcld_express_options['qcld_express_lang_out_of_stock'] !=''){
    $qcld_express_lang_out_of_stock = $qcld_express_options['qcld_express_lang_out_of_stock'];
    }else{
    $qcld_express_lang_out_of_stock = 'Out of Stock';
    }
    if(isset($qcld_express_options['qcld_express_lang_add_to_cart']) && $qcld_express_options['qcld_express_lang_add_to_cart'] !=''){
    $qcld_express_lang_add_to_cart = $qcld_express_options['qcld_express_lang_add_to_cart'];
    }else{
    $qcld_express_lang_add_to_cart = 'Add To Cart';
    }

    $qcld_express_cart_mode         = $qcld_express_options['qcld_express_cart_mode'];
   
    $p_id = trim($_POST['product_id']);
    $inStock = "<strong>InStock</strong>";
    //Woocommerce product factory
    $wc_pf = new WC_Product_Factory();
    $product = $wc_pf->get_product($p_id);
    //Getting product variation number based details

    $qcld_thumb = wp_get_attachment_image_src(get_post_thumbnail_id($p_id), 'shop_thumbnail');
    $qcld_large = wp_get_attachment_image_src( get_post_thumbnail_id( $p_id ), 'single-post-thumbnail' );

    if (!empty($qcld_thumb)) {
            $image = $qcld_thumb;
            $image_large =$qcld_large;
    } else {
        $image[0] = QCLD_EXPRESS_IMG_URL . '/placeholder.png';
        $image_large[0]=QCLD_EXPRESS_IMG_URL.'/placeholder.png';
    }
    

   // if($product->is_type( 'variation' ) ) {
    if($product->get_type()=='variable' ){

    //Attributes for vaiable product to display.
    $attributes = $product->get_attributes();
    $var_attrs=$product->get_variation_attributes();
    $varation_names=array();
       if(!empty($var_attrs)){
           foreach ($var_attrs as $key=>$value){
               array_push($varation_names,$key);
           }
       }
    $debug=$varation_names;
    }
   $attachment_ids = $product->get_gallery_attachment_ids();
    ob_start();
   ?>

            <div class="qcld-express-product-details">
            <div class="qcld-express-quick-left">
            <?php
            $attachment_ids = $product->get_gallery_attachment_ids();
            ?>
            
                <div class="qcld-express-product-img"><div class="clearfix" style="max-width:100%">
                    <ul id="image-gallery" class="gallery  list-unstyled cS-hidden">
                        <li data-thumb="<?php echo $image_large[0]; ?>">
                            <img  src="<?php echo $image_large[0]; ?>" alt="<?php echo get_the_title($p_id); ?>" />
                        </li>
                        <?php
                            foreach( $attachment_ids as $attachment_id ) {
                                $image_link = wp_get_attachment_url( $attachment_id, 'shop_thumbnail' );
                        ?>
                        <li data-thumb="<?php echo $image_link; ?>">
                            <img src="<?php echo $image_link; ?>" alt="<?php echo get_the_title($p_id); ?>"/>
                        </li>
                        <?php } ?>
                    </ul>
                    </div></div>
             
                </div>
            <div class="qcld-express-quick-right">

                <h2 id='qcld_epress_product_title' ><?php echo $product->get_title(); ?></h2>
                <?php
            $rating_count = $product->get_rating_count();

                if ($average = $product->get_average_rating()) :
                    ?>
                <ul class="woocommerce"><li>
                    <div class="star-rating" title="<?php echo sprintf(__( 'Rated %s out of 5', 'woocommerce' ), $average); ?>"><span style="width:<?php echo ( ( $average / 5 ) * 100 ); ?>%"><strong itemprop="ratingValue" class="rating"><?php echo $average; ?></strong><?php echo __( 'out of 5', 'woocommerce' ); ?></span></div>
            </li></ul>
            <?php  endif; ?>
            <p class="qcld-express-popup-price" id="qcld_express_vp_price"><?php echo $product->get_price_html(); ?></p>
            <div class="woocommerce-product-details__short-description">
                <p><?php echo strip_tags(get_the_excerpt($p_id)); ?></p>
            </div>

                <p class="qcld-express-product-cat"><?php echo $product->get_categories( ', ', '<span class="posted_in">' . _n( '<div class="qcld_ex_cat_name">'.$qcld_express_lang_category.':</div>', '<div class="qcld_ex_cat_name">'.$qcld_express_lang_category.':</div>', sizeof( get_the_terms( $p_id, 'product_cat' ) ), 'woocommerce' ) . ' ', '.</span>' ); 

            $stock = get_post_meta( $p_id, '_stock', true );
            $stock_status = get_post_meta( $p_id, '_stock_status', true );

            if( ($stock > 0 || $stock == '')  && $stock_status == "instock" ){

        
                if($product->get_type() == 'external'){

                  $link = sprintf( '<a rel="nofollow" href="%s" data-quantity="%s" data-product_id="%s" data-product_sku="%s" class="%s" target="_blank">%s</a>',
                          esc_url( $product->add_to_cart_url() ),
                          esc_attr( isset( $quantity ) ? $quantity : 1 ),
                          esc_attr( $product->id ),
                          esc_attr( $product->get_sku() ),
                          esc_attr( isset( $class ) ? $class : 'qcld_product_type_external qcld_express_button' ),
                          esc_html( $product->add_to_cart_text() )
                          );
                  echo $link;

                }else if($product->get_type()=='variable' ){

                    natsort($values);
                    if($qcld_express_lightbox_add_to_cart_button != 'on'){


                    global $woocommerce;

                    $suffix      = defined( 'SCRIPT_DEBUG' ) && SCRIPT_DEBUG ? '' : '.min';

                   

                    global $post;
                    if(intval($p_id)) {

                       wp('p=' . $p_id . '&post_type=product');
                       
                        while (have_posts()) : the_post();
                        ?>
                            <script>
                                var wc_add_to_cart_variation_params = {"ajax_url": "\/wp-admin\/admin-ajax.php"};
                                jQuery.getScript("<?php echo $woocommerce->plugin_url(); ?>/assets/js/frontend/add-to-cart-variation.min.js");

                            </script>
                            <div class="express-shop-product-variation-container">


                                 <div class="product">

                                    <div id="product-<?php the_ID(); ?>" <?php post_class('product'); ?>>
                                        <?php 
                                            do_action('qcld_express_product_variations'); 
                                        ?>



                                    </div>
                                </div>
                            </div>




                     <?php

                        endwhile;
                    }


                        }
               
        
            }else{

                $stock = get_post_meta( get_the_ID(), '_stock', true );
                $stock_status = get_post_meta( get_the_ID(), '_stock_status', true );

                if($qcld_express_lightbox_add_to_cart_button != 'on'){

                     if (isset($qcld_express_cart_mode) && $qcld_express_cart_mode == 'wooinstants') {

                        $qcld_woo_minmax_enable_plugin = get_option( 'qcld_woo_minmax_enable_plugin' );
                        if(function_exists('qcld_woo_minmax_install') && isset($qcld_woo_minmax_enable_plugin) && $qcld_woo_minmax_enable_plugin  == 'yes'){

                              $response_min_max = qcld_express_pro_add_rules_text($p_id,0);
                              $min_qty  = $response_min_max['min'] ? $response_min_max['min'] :1;
                              $max_qty  = $response_min_max['max'] ? $response_min_max['max'] : '';
                              $step_qty = $response_min_max['step'] ? $response_min_max['step'] : 1;

                          }else{
                            $min_qty  = 1;
                            $max_qty  = '';
                            $step_qty = 1;

                          }

                          ?>
                        <div class="qcld-express-carts-sec">
                        <div class="qcld-express-quantity">
                        <button class="qcld-express-qty-decrease" type="button">-</button>
                        <input type="text" value="<?php echo ($min_qty ? $min_qty : 1); ?>" step="<?php echo ($step_qty ? $step_qty : ''); ?>" min="<?php echo ($min_qty ? $min_qty : ''); ?>" max="<?php echo ($max_qty ? $max_qty : ''); ?>" id="qcld_quantity_value" name="qcld_quantity" class="qcld-express-simple-p-qnty qty " size="4">
                        <button class="qcld-express-qty-increase" type="button">+</button></div>
                            <a  class="ajax_add_to_cart add_to_cart_button product_type_simple  qcld_express_button" data-quantity="<?php echo ($min_qty ? $min_qty : 1); ?>" data-product_id="<?php echo $p_id; ?>" p-id="<?php echo $p_id; ?>" p-price="<?php echo $product->get_price(); ?>" ><?php echo $qcld_express_lang_add_to_cart; ?></a>
                        </div>


                <?php  }else{ ?>

                <div class="qcld-express-carts-sec">
                    <div class="qcld-express-quantity">
                        <button class="qcld-express-qty-decrease" type="button">-</button>
                        <input type="text" value="1" step="1" min="1" max="" id="qcld_quantity_value" name="qcld_quantity" class="qcld-express-simple-p-qnty qty " size="4">
                        <button class="qcld-express-qty-increase" type="button">+</button></div>
                            <a  class="qcld_express_s_p_pop qcld_express_button"  p-id="<?php echo $p_id; ?>"p-price="<?php echo $product->get_price(); ?>" ><?php echo $qcld_express_lang_add_to_cart; ?></a></div>
                <?php
                }
                }

            }

        }else{
            ?>
                <p class="qcld-express-out-of-stock"><?php echo $qcld_express_lang_out_of_stock; ?><p>
            <?php
        }

            if($product->get_sku() != ''){
                ?>
                <div class="product_meta">
                    <span class="posted_in"><p class="qcld-express-popup-sku"> SKU : <?php echo $product->get_sku(); ?></p></span>
                </div>

            <?php } ?>
            </div></div>
            <?php

    //   echo wp_send_json($output);

    echo  ob_get_clean();
    exit();
    
}



//Add to cart for simple product.
add_action('wp_ajax_sp_add_to_cart', 'qcld_express_pro_sp_add_to_cart');
add_action('wp_ajax_nopriv_sp_add_to_cart', 'qcld_express_pro_sp_add_to_cart');


function qcld_express_pro_sp_add_to_cart()
{

    $product_id = apply_filters( 'woocommerce_add_to_cart_product_id', absint( $_POST['p_id'] ) );
    $product_quantity = empty( $_POST['quantity'] ) ? 1 : apply_filters( 'woocommerce_stock_amount', $_POST['quantity'] );
    global $woocommerce;
    $result = $woocommerce->cart->add_to_cart($product_id,$product_quantity);
    if ($result != false) {
        echo wp_send_json('simple');
    } else {
        echo wp_send_json('error');
    }
    wp_die();
}




// single product ajax add to cart actions
add_action('wp_ajax_qcld_express_single_ajax_add_to_cart', 'qcld_express_pro_single_ajax_add_to_cart');
add_action('wp_ajax_nopriv_qcld_express_single_ajax_add_to_cart', 'qcld_express_pro_single_ajax_add_to_cart');

// single product ajax add to cart actions
function qcld_express_pro_single_ajax_add_to_cart() {

    $product_id = apply_filters('woocommerce_add_to_cart_product_id', absint($_POST['product_id']));
    $quantity = empty($_POST['quantity']) ? 1 : wc_stock_amount($_POST['quantity']);
    $variation_id = absint($_POST['variation_id']);
    $passed_validation = apply_filters('woocommerce_add_to_cart_validation', true, $product_id, $quantity);
    $product_status = get_post_status($product_id);

    if ($passed_validation && WC()->cart->add_to_cart($product_id, $quantity, $variation_id) && 'publish' === $product_status) {

        do_action('woocommerce_ajax_added_to_cart', $product_id);

        if ('yes' === get_option('woocommerce_cart_redirect_after_add')) {
            wc_add_to_cart_message(array($product_id => $quantity), true);
        }

        WC_AJAX::get_refreshed_fragments();

    } else {

        $data = array(
            'error' => true,
            'product_url' => apply_filters('woocommerce_cart_redirect_after_error', get_permalink($product_id), $product_id));

        echo wp_send_json($data);
    }

    wp_die();
}


//Add to cart for variable product.
add_action('wp_ajax_vp_add_to_cart', 'qcld_express_pro_vp_add_to_cart');
add_action('wp_ajax_nopriv_vp_add_to_cart', 'qcld_express_pro_vp_add_to_cart');

function qcld_express_pro_vp_add_to_cart()
{
    ob_start();
        
    $product_id = apply_filters( 'woocommerce_add_to_cart_product_id', absint( $_POST['product_id'] ) );
    $quantity = empty( $_POST['quantity'] ) ? 1 : apply_filters( 'woocommerce_stock_amount', $_POST['quantity'] );
    $variation_id = $_POST['variation_id'];
    $variation  = $_POST['variation'];
    $passed_validation = apply_filters( 'woocommerce_add_to_cart_validation', true, $product_id, $quantity );

    if ( $passed_validation && WC()->cart->add_to_cart( $product_id, $quantity, $variation_id, $variation  ) ) {
        do_action( 'woocommerce_ajax_added_to_cart', $product_id );
        if ( get_option( 'woocommerce_cart_redirect_after_add' ) == 'yes' ) {
            wc_add_to_cart_message( $product_id );
        }

        // Return fragments
        WC_AJAX::get_refreshed_fragments();
    } else {
        $this->json_headers();

        // If there was an error adding to the cart, redirect to the product page to show any errors
        $data = array(
            'error' => true,
            'product_url' => apply_filters( 'woocommerce_cart_redirect_after_error', get_permalink( $product_id ), $product_id )
            );
        echo json_encode( $data );
    }


    wp_die();

}