'use strict';

var scrollTimeout = null,
    menu = document.querySelector('.qcld-express-product-container');

window.addEventListener('scroll', function () {
    if (!scrollTimeout) {
        document.body.classList.add('_disable-pointer-events');
        menu.classList.add('-scrolled');
		console.log(menu.length)
    } else {
        clearTimeout(scrollTimeout);
    }

    scrollTimeout = setTimeout(function () {
        document.body.classList.remove('_disable-pointer-events');
        menu.classList.remove('-scrolled');
        scrollTimeout = null;
    }, 150);
});